#ifndef AVANCEMENT_H
#define AVANCEMENT_H
#include <stdio.h>

enum XMState{
	XMST_VOID,  // Etat vide;
	XMST_BUSY,  // Occupe: soit XMATH crit soit VDK lit
	XMST_FREE,  // Libre;
	XMST_KILL}; // Arrt demande

	
class Avancement;
class HandleCore
{
public:
	HandleCore(){};
	virtual int ReachCore(Avancement *av)=0;
	virtual ~HandleCore(){};
};

class Avancement
{
		HandleCore *mHandleCore;
	protected:
		int mNStage;		// Nombre d'tape
		int mNStatement;	// Nombre d'instruction
		int mStage;		// Etape en cours
		int mStatement;		// Instruction en cours
		XMState mState;
		char *mStageName;	// Nom de l'tape en cours
	public:
		Avancement();
		Avancement(Avancement *av);
		HandleCore *&Handle();
		int ReachCore();
		int &NStage();
		int &NStatement();
		int &Stage();
		int &Statement();
		int &State();
		int IsVoid();
		int IsBusy();
		int IsFree();
		int SetVoid();
		int SetBusy();
		int SetFree();
		double Total();
		char *&StageName();
};

#endif   /* AVANCEMENT_H */