#include <ClientCommunication.h>
#include <ToolsXMProtocol.h>

extern void GThreadWait(double );

static  double gThreadWait=0.1;
static	int gIDListener=0;
static	int gStatusListener=0;

int SendTo(int idWrite, XMQuery *pQuery);
XMReponse * ReceiveFrom(int idRead);
SCConnection *MakeSCConnection(XMPipe *pipe, int id_client);

void SetThreadWait(double pause)
{
	gThreadWait = pause;
}

SCConnection *MakeSCConnection(XMPipe *pipe, int id_client)
{
	SCConnection *con;
	con = new SCConnection;
	con->mID = id_client;
	con->mPipe = pipe;
	return con;
}

XMPipe *CreerFluxCommunication(char *canal, int id, XMPipe *pipe)
{
	char AdresseW[strlen(canal)+strlen("/XMCorePipe")+11];
	char AdresseR[strlen(canal)+strlen("/XMCorePipe")+11];
	int RStatut, WStatut;
	
	if (id != -1)
	{
		sprintf(AdresseW, "%s/XMCorePipe%5.5dW", canal, id);
		sprintf(AdresseR, "%s/XMCorePipe%5.5dR", canal, id);
	}else
	{
		sprintf(AdresseW, "%s/XMCorePipeW", canal);
		sprintf(AdresseR, "%s/XMCorePipeR", canal);
	}
	if ((pipe->IDWrite = open(AdresseW, O_RDWR)) == -1)
	{
		printf("Erreur d'ouverture du canal de communication [%s]\n", AdresseW);
		pipe->IDRead = pipe->IDWrite = 0;
		return pipe;
	}
	if ((pipe->IDRead = open(AdresseR, O_RDWR)) == -1)
	{
		printf("Erreur d'ouverture du canal de communication [%s]\n", AdresseR);
		pipe->IDRead = pipe->IDWrite = 0;
		return pipe;
	}
	WStatut = fcntl(pipe->IDWrite, F_GETFL);
	fcntl(pipe->IDWrite, F_SETFL, WStatut | O_NONBLOCK);
	RStatut = fcntl(pipe->IDRead, F_GETFL);
	fcntl(pipe->IDRead, F_SETFL, RStatut | O_NONBLOCK);
	//printf("Cration d'un flux de communication\n");
	//printf("CLIENT[%d]    -- [%d]: %s\n", id, pipe->IDWrite, AdresseW);
	//printf("CLIENT[%d]    -- [%d]: %s\n", id, pipe->IDRead, AdresseR);
	return pipe;
}

SCConnection *ConnectToServer(char *adresse)
{
	SCConnection *con=NULL;
	XMPipe *pipe;
	XMReponse *reponse;
	int Attente=1000;
	
	pipe = CreerFluxCommunication(adresse, -1, new XMPipe);
	if (!pipe) return NULL;
	SendTo(pipe->IDWrite, MakeQuery(new XMQuery, 0, CQCONNECTION, NULL));
	for (int k=0;(!(reponse = ReceiveFrom(pipe->IDRead))) && (k<Attente); k++) sleep(1);
	close(pipe->IDRead); close(pipe->IDWrite);
	delete pipe;
	if (reponse)
		return MakeSCConnection(CreerFluxCommunication(adresse, reponse->IDClient, new XMPipe), reponse->IDClient);
	return NULL;
}

int SendTo(int idWrite, XMQuery *pQuery)
{
	int Result = -1;
	int attente=9999;
	for (int k=0; ((Result = write(idWrite, pQuery, sizeof(XMQuery)) == -1) && (k<attente)); k++);
	return Result;
}

int SendToServer(SCConnection * con, XMQuery *pQuery)
{
	int Result = -1;
	int attente=9999;
	//printf("Appel SendTo\n");
	for (int k=0; ((Result = write(con->mPipe->IDWrite, pQuery, sizeof(XMQuery)) == -1) && (k<attente)); k++);
	return Result;
}

XMReponse * ReceiveFrom(int idRead)
{
	static XMReponse Flux;
	return (read(idRead, &Flux, sizeof(XMReponse)) ==-1?NULL:&Flux);
}

XMReponse * ReceiveFromServer(SCConnection * con)
{
	int Result = -1;
	int attente=9999;
	static XMReponse Flux;
	for (int k=0; ((Result=read(con->mPipe->IDRead, &Flux, sizeof(XMReponse)))==-1) && (k<attente); k++);
	return (Result == -1? NULL: &Flux);
}

int DisconnectToServer(SCConnection * con)
{
	int k;
	int Result=0;
	int attente=9999;
	XMQuery query;
	
	for (k=0; ((Result=SendToServer(con, MakeQuery(&query, con->mID, CQDECONNECTION, NULL))) && (k<attente)); k++);
	if (Result == -1) return 0;
	for (k=0; ((Result=(int)ReceiveFromServer(con)) && (k<attente)); k++) sleep(2);
	if (Result == 0) return 0;
	return 1;
}

int ShutdownServer(SCConnection * con)
{
	int k;
	int Result=0;
	int attente=9999;
	XMQuery query;
	
	for (k=0; ((Result=SendToServer(con, MakeQuery(&query, con->mID, CQSHUTDOWN, NULL))) && (k<attente)); k++);
	if (Result == -1) return 0;
	for (k=0; ((Result=(int)ReceiveFromServer(con)) && (k<attente)); k++) sleep(2);
	if (Result == 0) return 0;
	return 1;
}

/*************************************************/
/*************************************************/
XMQuery *InitQuery(XMQuery *query)
{
	if (!query) return NULL;
	query->IDQuery = CQUNKNOWN;
	return query;
}
/*************************************************/
/*************************************************/

XMQuery * MakeQuery(XMQuery *query, int id_client, int id_query, char *data)
{
	int len,k;
	query->IDClient	= id_client;
	query->IDQuery = id_query;
	//printf("Identifiant de la requete: %d requete %s\n", id_query, data);
	if (!data) sprintf(query->Query, "%d#", id_query); else sprintf(query->Query, "%d#%s#", id_query, data);
	return query;
}
/*************************************************/
/*************************************************/

int 	 ReadReponse(XMReponse *reponse, int &id_client, int &id_reponse, char *data)
{
	id_client = reponse->IDClient;
	id_reponse = reponse->IDReponse;
	data = new char[strlen(reponse->Reponse) + 1];
	sprintf(data, "%s", reponse->Reponse);
	return id_reponse;
}
/*************************************************/
/*************************************************/


typedef struct Pack
{
	int IDRead;
	HandleServer *Hdle;
};

void *ListenerServer(void *data)
{
	XMReponse *reponse;
	int IDRead = (int)(((Pack *)data)->IDRead);
	HandleServer *Hdle = (HandleServer *)(((Pack *)data)->Hdle);
	int k;
	
	while (gStatusListener)
	{
		//select(...)
		if ((reponse = ReceiveFrom(IDRead)) != NULL)
			Hdle->TreateReponse(reponse);
		//for (k=0; k<Attente; k++);
		GThreadWait(gThreadWait);
	}
	printf("Fin client  l'coute\n");
	return NULL;
}

/********************************************************************/
int ListenToServer(SCConnection * con, int status, HandleServer *hdle)
{
	//printf("Appel listener: IDUSER %d    STATUS %d    Hdle: %p\n", con->mID, status, hdle);
	if (!status) gStatusListener=0;
	//if (gStatusListener) return gStatusListener;
	
	pthread_t thread;
	pthread_attr_t pthread_attr;
	Pack *pack;
	
	pack = new Pack;
	//printf("Listener sur: IDREAD %d   Hdle: %p\n", con->mPipe->IDRead, hdle);
	pack->IDRead = con->mPipe->IDRead;
	pack->Hdle = hdle;
	pthread_attr_init(&pthread_attr);
	pthread_create (&thread, &pthread_attr, ListenerServer, pack);
	
	return (gStatusListener=thread);
}