#include <stdio.h>
#include <VGlobale.h>
#include <Communication.h>
#include <Assistant.h>


char *GetNameOfFluxCommunication(char RW, int id)
{
	char *AdresseRW=NULL;
	
	if (id != -1)
	{
		AdresseRW = new char[strlen(GetVGlobale(VG_CANAL_FLUX))+strlen("/XMCorePipe")+10+1+1];
		sprintf(AdresseRW, "%s/XMCorePipe%5.5d%c", GetVGlobale(VG_CANAL_FLUX), id, RW);
	}else
	{
		AdresseRW = new char[strlen(GetVGlobale(VG_CANAL_FLUX))+strlen("/XMCorePipe")+1+1];
		sprintf(AdresseRW, "%s/XMCorePipe%c", GetVGlobale(VG_CANAL_FLUX), RW);
	}
	return AdresseRW;
}

XMPipe *CreerFluxCommunication(int id, XMPipe *pipe)
{
	char AdresseW[strlen(GetVGlobale(VG_CANAL_FLUX))+strlen("/XMCorePipe")+10];
	char AdresseR[strlen(GetVGlobale(VG_CANAL_FLUX))+strlen("/XMCorePipe")+10];
	int RStatut, WStatut;
		
	if (id != -1)
	{
		sprintf(AdresseW, "%s/XMCorePipe%5.5dR", GetVGlobale(VG_CANAL_FLUX), id);
		sprintf(AdresseR, "%s/XMCorePipe%5.5dW", GetVGlobale(VG_CANAL_FLUX), id);
		
	}else
	{
		sprintf(AdresseW, "%s/XMCorePipeR", GetVGlobale(VG_CANAL_FLUX));
		sprintf(AdresseR, "%s/XMCorePipeW", GetVGlobale(VG_CANAL_FLUX));
	}
	if (mkfifo(AdresseW, S_IRUSR|S_IWUSR|S_IRGRP) == -1)
	{
		printf("Erreur de cration du canal de communication [%s]\n", AdresseW);
		exit(0);
	}
	if (mkfifo(AdresseR, S_IRUSR|S_IWUSR|S_IRGRP) == -1)
	{
		printf("Erreur de cration du canal de communication [%s]\n", AdresseR);
		exit(0);
	}
	if ((pipe->IDWrite = open(AdresseW, O_RDWR)) == -1)
	{
		printf("Erreur d'ouverture du canal de communication\n");
		delete pipe;
		return NULL;
	}
	if ((pipe->IDRead = open(AdresseR, O_RDWR)) == -1)
	{
		printf("Erreur d'ouverture du canal de communication\n");
		delete pipe;
		return NULL;
	}
	WStatut = fcntl(pipe->IDWrite, F_GETFL);
	fcntl(pipe->IDWrite, F_SETFL, WStatut | O_NONBLOCK);
	RStatut = fcntl(pipe->IDRead, F_GETFL);
	fcntl(pipe->IDRead, F_SETFL, RStatut | O_NONBLOCK);
	return (pipe);
}

SCConnection * ConnectClientToServer()
{
	return ConnectClient();
}

XMQuery *ReadQueryFromClient()
{
	static XMQuery Flux;
	XMPipe *Client;
	int k;
	
	for(k=0; Client=GetPipeConnection(k); k++)
		if (read(Client->IDRead, &Flux, sizeof(XMQuery)) != -1) return ((XMQuery *)(&Flux));
	if (k<=3) sleep(1); else if (k==4) for (int j=0; j<10000;j++); else if (k==5) for (int j=0; j<7000;j++);
	return NULL;
}

int	SendReponseToClient(XMPipe *pipe, XMReponse *pReponse)
{
	//printf("Envoye sur: [%d]\n", pipe->IDWrite);
	return (write(pipe->IDWrite, pReponse, sizeof(XMReponse)));
}

int	SendFileReponseToClient(XMPipe *pipe, CFile<XMReponse *> *fReponse)
{
	int NbPacketEnvoyes=0;
	XMReponse *pReponse;
	while (!fReponse->Vide())
	{
		fReponse->Defiler(pReponse);
		printf("ENVOI>> IDClient: %d  IDReponse: %d  Reponse: %s\n", pReponse->IDClient, pReponse->IDReponse, pReponse->Reponse);
		for (;SendReponseToClient(pipe, pReponse)==-1;) for(int k=0;k<150;k++);
		NbPacketEnvoyes++;
		delete pReponse;
	}
	delete fReponse;
	return NbPacketEnvoyes;
}

void DetruireFluxCommunation(XMPipe *&pipe, int id_user)
{
	char *W, *R;
	close(pipe->IDWrite);
	close(pipe->IDRead);
	
	W = GetNameOfFluxCommunication('W', id_user);
	R = GetNameOfFluxCommunication('R', id_user);
	//printf("CANAL: %s\n", W);
	unlink(W); unlink(R);
	delete W;  delete R;
	delete pipe;
	pipe = NULL;
}

int DisconnectClientToServer(int id_user)
{
	if (id_user > -1)	return (DisconnectClient(id_user, DetruireFluxCommunation)?1:0);
	if (id_user == -1)	return  DisconnectAllClient(DetruireFluxCommunation);
	return 0;
}

int   ReadQuery(XMQuery *query, int &id_client, int &id_query, char *data)
{
	id_client	= query->IDClient;
	id_query	= query->IDQuery;
	sprintf(data, "%s", query->Query);
	return id_query;
}

/*************************************************/
/*************************************************/
XMReponse *InitReponse(XMReponse *reponse)
{
	if (!reponse) return NULL;
	reponse->IDReponse = XMRUNKNOWN;
	reponse->Reponse[0]='\0';
	return reponse;
}
/*************************************************/
/*************************************************/

XMReponse * MakeReponse(XMReponse *reponse, int id_client, int id_reponse, void *data)
{
	reponse->IDClient	= id_client;
	reponse->IDReponse	= id_reponse;
	if (!data) return reponse;
	sprintf(reponse->Reponse, "%s", data);
	return reponse;
}