/****************************************************************/
/*  Dfintion des onctions pour l'oprateur de comparaison '<'	*/
/****************************************************************/
/****************************************************************/

/****************************************************************/
/***********************	BYTE	*************************/
/****************************************************************/

template <class X, class Y> bool StrictementInferieur(X, Y, void *val1, void *val2)
{
	X *aValue1;
	Y *aValue2;
	aValue1 = (X *)val1;
	aValue2 = (Y *)val2;
	return ((X (*aValue1)) < (Y (*aValue2)));
}

bool StrictementInferieurSBSB(void *val1, void *val2)
{
	byte *aValue1;
	byte *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (byte *)val2;
	return ((*aValue1) < (*aValue2));
}

bool StrictementInferieurSBSI(void *val1, void *val2)
{
	byte *aValue1;
	int *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (int *)val2;
	return ((*aValue1) < (*aValue2));
}

bool StrictementInferieurSBSD(void *val1, void *val2)
{
	byte *aValue1;
	double *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (double *)val2;
	return ((*aValue1) < (*aValue2));
}

bool StrictementInferieurSBSF(void *val1, void *val2)
{
	byte *aValue1;
	float *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (float *)val2;
	return ((*aValue1) < (*aValue2));
}

bool StrictementInferieurSBSL(void *val1, void *val2)
{
	byte *aValue1;
	long *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long *)val2;
	return ((*aValue1) < (*aValue2));
}

bool StrictementInferieurSBLB(void *val1, void *val2)
{
	byte *aValue1;
	long byte *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long byte *)val2;
	return ((*aValue1) < (*aValue2));
}

bool StrictementInferieurSBLI(void *val1, void *val2)
{
	byte *aValue1;
	long int *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long int *)val2;
	return ((*aValue1) < (*aValue2));
}
bool StrictementInferieurSBLD(void *val1, void *val2)
{
	byte *aValue1;
	long double *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long double *)val2;
	return ((*aValue1) < (*aValue2));
}

bool StrictementInferieurSBLF(void *val1, void *val2)
{
	byte *aValue1;
	long float *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long float *)val2;
	return ((*aValue1) < (*aValue2));
}

bool StrictementInferieurSBLL(void *val1, void *val2)
{
	byte *aValue1;
	long long *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long long *)val2;
	return ((*aValue1) < (*aValue2));
}

bool StrictementInferieurLBSB(void *val1, void *val2)
{
	return (StrictementInferieurSBLB(val2, val1));
}

bool StrictementInferieurLBSI(void *val1, void *val2)
{
	return (StrictementInferieurSILB(val2, val1));
}

bool StrictementInferieurLBSD(void *val1, void *val2)
{
	return (StrictementInferieurSBLB(val2, val1));
}

bool StrictementInferieurLBSF(void *val1, void *val2)
{
	return (StrictementInferieurSFLB(val2, val1));
}

bool StrictementInferieurLBSL(void *val1, void *val2)
{
	return (StrictementInferieurSLLB(val2, val1));
}

bool StrictementInferieurLBLB(void *val1, void *val2)
{
	long byte *aValue1;
	long byte *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long byte *)val2;
	return ((*aValue1) < (*aValue2));
}

bool StrictementInferieurLBLI(void *val1, void *val2)
{
	long byte *aValue1;
	long int *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long int *)val2;
	return ((*aValue1) < (*aValue2));
}

bool StrictementInferieurLBLD(void *val1, void *val2)
{
	long byte *aValue1;
	long double *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long double *)val2;
	return ((*aValue1) < (*aValue2));
}

bool StrictementInferieurLBLF(void *val1, void *val2)
{
	long byte *aValue1;
	long float *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long float *)val2;
	return ((*aValue1) < (*aValue2));
}

bool StrictementInferieurLBLL(void *val1, void *val2)
{
	long byte *aValue1;
	long long *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long long *)val2;
	return ((*aValue1) < (*aValue2));
}

/****************************************************************/
/***************************	INT	*************************/
/****************************************************************/
bool StrictementInferieurSISB(void *val1, void *val2)
{
	byte *aValue1;
	byte *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (byte *)val2;
	return ((*aValue1) < (*aValue2));
}

bool StrictementInferieurSISI(void *val1, void *val2)
{
	byte *aValue1;
	int *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (int *)val2;
	return ((*aValue1) < (*aValue2));
}

bool StrictementInferieurSISD(void *val1, void *val2)
{
	byte *aValue1;
	double *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (double *)val2;
	return ((*aValue1) < (*aValue2));
}

bool StrictementInferieurSISF(void *val1, void *val2)
{
	byte *aValue1;
	float *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (float *)val2;
	return ((*aValue1) < (*aValue2));
}

bool StrictementInferieurSISL(void *val1, void *val2)
{
	byte *aValue1;
	long *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long *)val2;
	return ((*aValue1) < (*aValue2));
}

bool StrictementInferieurSILB(void *val1, void *val2)
{
	byte *aValue1;
	long byte *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long byte *)val2;
	return ((*aValue1) < (*aValue2));
}

bool StrictementInferieurSILI(void *val1, void *val2)
{
	byte *aValue1;
	long int *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long int *)val2;
	return ((*aValue1) < (*aValue2));
}
bool StrictementInferieurSILD(void *val1, void *val2)
{
	byte *aValue1;
	long double *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long double *)val2;
	return ((*aValue1) < (*aValue2));
}

bool StrictementInferieurSILF(void *val1, void *val2)
{
	byte *aValue1;
	long float *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long float *)val2;
	return ((*aValue1) < (*aValue2));
}

bool StrictementInferieurSILL(void *val1, void *val2)
{
	byte *aValue1;
	long long *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long long *)val2;
	return ((*aValue1) < (*aValue2));
}

bool StrictementInferieurLISB(void *val1, void *val2)
{
	return (StrictementInferieurSBLB(val2, val1));
}

bool StrictementInferieurLISI(void *val1, void *val2)
{
	return (StrictementInferieurSILB(val2, val1));
}

bool StrictementInferieurLISD(void *val1, void *val2)
{
	return (StrictementInferieurSBLB(val2, val1));
}

bool StrictementInferieurLISF(void *val1, void *val2)
{
	return (StrictementInferieurSFLB(val2, val1));
}

bool StrictementInferieurLISL(void *val1, void *val2)
{
	return (StrictementInferieurSLLB(val2, val1));
}

bool StrictementInferieurLILB(void *val1, void *val2)
{
	long byte *aValue1;
	long byte *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long byte *)val2;
	return ((*aValue1) < (*aValue2));
}

bool StrictementInferieurLILI(void *val1, void *val2)
{
	long byte *aValue1;
	long int *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long int *)val2;
	return ((*aValue1) < (*aValue2));
}

bool StrictementInferieurLILD(void *val1, void *val2)
{
	long byte *aValue1;
	long double *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long double *)val2;
	return ((*aValue1) < (*aValue2));
}

bool StrictementInferieurLILF(void *val1, void *val2)
{
	long byte *aValue1;
	long float *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long float *)val2;
	return ((*aValue1) < (*aValue2));
}

bool StrictementInferieurLILL(void *val1, void *val2)
{
	long byte *aValue1;
	long long *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long long *)val2;
	return ((*aValue1) < (*aValue2));
}
/****************************************************************/

/****************************************************************/


/****************************************************************/
/*	 Fonctions pour l'oprateur de comparaison '>'		*/
/****************************************************************/
/****************************************************************/
bool StrictementSuperieurSBSB(void *val1, void *val2)
{
	byte *aValue1;
	byte *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (byte *)val2;
	return ((*aValue1) > (*aValue2));
}

bool StrictementSuperieurSBSI(void *val1, void *val2)
{
	byte *aValue1;
	int *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (int *)val2;
	return ((*aValue1) > (*aValue2));
}

bool StrictementSuperieurSBSD(void *val1, void *val2)
{
	byte *aValue1;
	double *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (double *)val2;
	return ((*aValue1) > (*aValue2));
}

bool StrictementSuperieurSBSF(void *val1, void *val2)
{
	byte *aValue1;
	float *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (float *)val2;
	return ((*aValue1) > (*aValue2));
}

bool StrictementSuperieurSBSL(void *val1, void *val2)
{
	byte *aValue1;
	long *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long *)val2;
	return ((*aValue1) > (*aValue2));
}

bool StrictementSuperieurSBLB(void *val1, void *val2)
{
	byte *aValue1;
	long byte *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long byte *)val2;
	return ((*aValue1) > (*aValue2));
}

bool StrictementSuperieurSBLI(void *val1, void *val2)
{
	byte *aValue1;
	long int *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long int *)val2;
	return ((*aValue1) > (*aValue2));
}
bool StrictementSuperieurSBLD(void *val1, void *val2)
{
	byte *aValue1;
	long double *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long double *)val2;
	return ((*aValue1) > (*aValue2));
}

bool StrictementSuperieurSBLF(void *val1, void *val2)
{
	byte *aValue1;
	long float *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long float *)val2;
	return ((*aValue1) > (*aValue2));
}

bool StrictementSuperieurSBLL(void *val1, void *val2)
{
	byte *aValue1;
	long long *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long long *)val2;
	return ((*aValue1) > (*aValue2));
}

bool StrictementSuperieurLBSB(void *val1, void *val2)
{
	return (StrictementSuperieurSBLB(val2, val1));
}

bool StrictementSuperieurLBSI(void *val1, void *val2)
{
	return (StrictementSuperieurSILB(val2, val1));
}

bool StrictementSuperieurLBSD(void *val1, void *val2)
{
	return (StrictementSuperieurSBLB(val2, val1));
}

bool StrictementSuperieurLBSF(void *val1, void *val2)
{
	return (StrictementSuperieurSFLB(val2, val1));
}

bool StrictementSuperieurLBSL(void *val1, void *val2)
{
	return (StrictementSuperieurSLLB(val2, val1));
}

bool StrictementSuperieurLBLB(void *val1, void *val2)
{
	long byte *aValue1;
	long byte *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long byte *)val2;
	return ((*aValue1) > (*aValue2));
}

bool StrictementSuperieurLBLI(void *val1, void *val2)
{
	long byte *aValue1;
	long int *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long int *)val2;
	return ((*aValue1) > (*aValue2));
}

bool StrictementSuperieurLBLD(void *val1, void *val2)
{
	long byte *aValue1;
	long double *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long double *)val2;
	return ((*aValue1) > (*aValue2));
}

bool StrictementSuperieurLBLF(void *val1, void *val2)
{
	long byte *aValue1;
	long float *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long float *)val2;
	return ((*aValue1) > (*aValue2));
}

bool StrictementSuperieurLBLL(void *val1, void *val2)
{
	long byte *aValue1;
	long long *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long long *)val2;
	return ((*aValue1) > (*aValue2));
}
/****************************************************************/


/****************************************************************/
/*	 Fonctions pour l'oprateur de comparaison '<='		*/
/****************************************************************/
/****************************************************************/
bool InferieurOuEgalSBSB(void *val1, void *val2)
{
	byte *aValue1;
	byte *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (byte *)val2;
	return ((*aValue1) <= (*aValue2));
}

bool InferieurOuEgalSBSI(void *val1, void *val2)
{
	byte *aValue1;
	int *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (int *)val2;
	return ((*aValue1) <= (*aValue2));
}

bool InferieurOuEgalSBSD(void *val1, void *val2)
{
	byte *aValue1;
	double *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (double *)val2;
	return ((*aValue1) <= (*aValue2));
}

bool InferieurOuEgalSBSF(void *val1, void *val2)
{
	byte *aValue1;
	float *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (float *)val2;
	return ((*aValue1) <= (*aValue2));
}

bool InferieurOuEgalSBSL(void *val1, void *val2)
{
	byte *aValue1;
	long *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long *)val2;
	return ((*aValue1) <= (*aValue2));
}

bool InferieurOuEgalSBLB(void *val1, void *val2)
{
	byte *aValue1;
	long byte *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long byte *)val2;
	return ((*aValue1) <= (*aValue2));
}

bool InferieurOuEgalSBLI(void *val1, void *val2)
{
	byte *aValue1;
	long int *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long int *)val2;
	return ((*aValue1) <= (*aValue2));
}
bool InferieurOuEgalSBLD(void *val1, void *val2)
{
	byte *aValue1;
	long double *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long double *)val2;
	return ((*aValue1) <= (*aValue2));
}

bool InferieurOuEgalSBLF(void *val1, void *val2)
{
	byte *aValue1;
	long float *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long float *)val2;
	return ((*aValue1) <= (*aValue2));
}

bool InferieurOuEgalSBLL(void *val1, void *val2)
{
	byte *aValue1;
	long long *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long long *)val2;
	return ((*aValue1) <= (*aValue2));
}

bool InferieurOuEgalLBSB(void *val1, void *val2)
{
	return (InferieurOuEgalSBLB(val2, val1));
}

bool InferieurOuEgalLBSI(void *val1, void *val2)
{
	return (InferieurOuEgalSILB(val2, val1));
}

bool InferieurOuEgalLBSD(void *val1, void *val2)
{
	return (InferieurOuEgalSBLB(val2, val1));
}

bool InferieurOuEgalLBSF(void *val1, void *val2)
{
	return (InferieurOuEgalSFLB(val2, val1));
}

bool InferieurOuEgalLBSL(void *val1, void *val2)
{
	return (InferieurOuEgalSLLB(val2, val1));
}

bool InferieurOuEgalLBLB(void *val1, void *val2)
{
	long byte *aValue1;
	long byte *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long byte *)val2;
	return ((*aValue1) <= (*aValue2));
}

bool InferieurOuEgalLBLI(void *val1, void *val2)
{
	long byte *aValue1;
	long int *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long int *)val2;
	return ((*aValue1) <= (*aValue2));
}

bool InferieurOuEgalLBLD(void *val1, void *val2)
{
	long byte *aValue1;
	long double *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long double *)val2;
	return ((*aValue1) <= (*aValue2));
}

bool InferieurOuEgalLBLF(void *val1, void *val2)
{
	long byte *aValue1;
	long float *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long float *)val2;
	return ((*aValue1) <= (*aValue2));
}

bool InferieurOuEgalLBLL(void *val1, void *val2)
{
	long byte *aValue1;
	long long *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long long *)val2;
	return ((*aValue1) <= (*aValue2));
}
/****************************************************************/


/****************************************************************/
/*	 Fonctions pour l'oprateur de comparaison '>='		*/
/****************************************************************/
/****************************************************************/
bool SuperieurOuEgalSBSB(void *val1, void *val2)
{
	byte *aValue1;
	byte *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (byte *)val2;
	return ((*aValue1) >= (*aValue2));
}

bool SuperieurOuEgalSBSI(void *val1, void *val2)
{
	byte *aValue1;
	int *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (int *)val2;
	return ((*aValue1) >= (*aValue2));
}

bool SuperieurOuEgalSBSD(void *val1, void *val2)
{
	byte *aValue1;
	double *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (double *)val2;
	return ((*aValue1) >= (*aValue2));
}

bool SuperieurOuEgalSBSF(void *val1, void *val2)
{
	byte *aValue1;
	float *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (float *)val2;
	return ((*aValue1) >= (*aValue2));
}

bool SuperieurOuEgalSBSL(void *val1, void *val2)
{
	byte *aValue1;
	long *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long *)val2;
	return ((*aValue1) >= (*aValue2));
}

bool SuperieurOuEgalSBLB(void *val1, void *val2)
{
	byte *aValue1;
	long byte *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long byte *)val2;
	return ((*aValue1) >= (*aValue2));
}

bool SuperieurOuEgalSBLI(void *val1, void *val2)
{
	byte *aValue1;
	long int *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long int *)val2;
	return ((*aValue1) >= (*aValue2));
}
bool SuperieurOuEgalSBLD(void *val1, void *val2)
{
	byte *aValue1;
	long double *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long double *)val2;
	return ((*aValue1) >= (*aValue2));
}

bool SuperieurOuEgalSBLF(void *val1, void *val2)
{
	byte *aValue1;
	long float *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long float *)val2;
	return ((*aValue1) >= (*aValue2));
}

bool SuperieurOuEgalSBLL(void *val1, void *val2)
{
	byte *aValue1;
	long long *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long long *)val2;
	return ((*aValue1) >= (*aValue2));
}

bool SuperieurOuEgalLBSB(void *val1, void *val2)
{
	return (SuperieurOuEgalSBLB(val2, val1));
}

bool SuperieurOuEgalLBSI(void *val1, void *val2)
{
	return (SuperieurOuEgalSILB(val2, val1));
}

bool SuperieurOuEgalLBSD(void *val1, void *val2)
{
	return (SuperieurOuEgalSBLB(val2, val1));
}

bool SuperieurOuEgalLBSF(void *val1, void *val2)
{
	return (SuperieurOuEgalSFLB(val2, val1));
}

bool SuperieurOuEgalLBSL(void *val1, void *val2)
{
	return (SuperieurOuEgalSLLB(val2, val1));
}

bool SuperieurOuEgalLBLB(void *val1, void *val2)
{
	long byte *aValue1;
	long byte *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long byte *)val2;
	return ((*aValue1) >= (*aValue2));
}

bool SuperieurOuEgalLBLI(void *val1, void *val2)
{
	long byte *aValue1;
	long int *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long int *)val2;
	return ((*aValue1) >= (*aValue2));
}

bool SuperieurOuEgalLBLD(void *val1, void *val2)
{
	long byte *aValue1;
	long double *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long double *)val2;
	return ((*aValue1) >= (*aValue2));
}

bool SuperieurOuEgalLBLF(void *val1, void *val2)
{
	long byte *aValue1;
	long float *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long float *)val2;
	return ((*aValue1) >= (*aValue2));
}

bool SuperieurOuEgalLBLL(void *val1, void *val2)
{
	long byte *aValue1;
	long long *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long long *)val2;
	return ((*aValue1) >= (*aValue2));
}
/****************************************************************/


/****************************************************************/
/*	 Fonctions pour l'oprateur de comparaison '=='		*/
/****************************************************************/
/****************************************************************/
bool EgalSBSB(void *val1, void *val2)
{
	byte *aValue1;
	byte *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (byte *)val2;
	return ((*aValue1) == (*aValue2));
}

bool EgalSBSI(void *val1, void *val2)
{
	byte *aValue1;
	int *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (int *)val2;
	return ((*aValue1) == (*aValue2));
}

bool EgalSBSD(void *val1, void *val2)
{
	byte *aValue1;
	double *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (double *)val2;
	return ((*aValue1) == (*aValue2));
}

bool EgalSBSF(void *val1, void *val2)
{
	byte *aValue1;
	float *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (float *)val2;
	return ((*aValue1) == (*aValue2));
}

bool EgalSBSL(void *val1, void *val2)
{
	byte *aValue1;
	long *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long *)val2;
	return ((*aValue1) == (*aValue2));
}

bool EgalSBLB(void *val1, void *val2)
{
	byte *aValue1;
	long byte *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long byte *)val2;
	return ((*aValue1) == (*aValue2));
}

bool EgalSBLI(void *val1, void *val2)
{
	byte *aValue1;
	long int *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long int *)val2;
	return ((*aValue1) == (*aValue2));
}
bool EgalSBLD(void *val1, void *val2)
{
	byte *aValue1;
	long double *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long double *)val2;
	return ((*aValue1) == (*aValue2));
}

bool EgalSBLF(void *val1, void *val2)
{
	byte *aValue1;
	long float *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long float *)val2;
	return ((*aValue1) == (*aValue2));
}

bool EgalSBLL(void *val1, void *val2)
{
	byte *aValue1;
	long long *aValue2;
	aValue1 = (byte *)val1;
	aValue2 = (long long *)val2;
	return ((*aValue1) == (*aValue2));
}

bool EgalLBSB(void *val1, void *val2)
{
	return (EgalSBLB(val2, val1));
}

bool EgalLBSI(void *val1, void *val2)
{
	return (EgalSILB(val2, val1));
}

bool EgalLBSD(void *val1, void *val2)
{
	return (EgalSBLB(val2, val1));
}

bool EgalLBSF(void *val1, void *val2)
{
	return (EgalSFLB(val2, val1));
}

bool EgalLBSL(void *val1, void *val2)
{
	return (EgalSLLB(val2, val1));
}

bool EgalLBLB(void *val1, void *val2)
{
	long byte *aValue1;
	long byte *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long byte *)val2;
	return ((*aValue1) == (*aValue2));
}

bool EgalLBLI(void *val1, void *val2)
{
	long byte *aValue1;
	long int *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long int *)val2;
	return ((*aValue1) == (*aValue2));
}

bool EgalLBLD(void *val1, void *val2)
{
	long byte *aValue1;
	long double *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long double *)val2;
	return ((*aValue1) == (*aValue2));
}

bool EgalLBLF(void *val1, void *val2)
{
	long byte *aValue1;
	long float *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long float *)val2;
	return ((*aValue1) == (*aValue2));
}

bool EgalLBLL(void *val1, void *val2)
{
	long byte *aValue1;
	long long *aValue2;
	aValue1 = (long byte *)val1;
	aValue2 = (long long *)val2;
	return ((*aValue1) == (*aValue2));
}
/****************************************************************/

#define PFUNCTION  bool (*)(void *val1, void *val2)


PFUNCTION *GetTABPFonctionComparateur(TOperateur top)
{
	int i=0;
	PFUNCTION *aTABFonction=NULL;
	switch (top)
	{
		case TOP_STRICT_INF: //Operateur '<'
			{
				aTABFonction = new PFUNCTION[TV_LAST*4];
				aTABFonction[i] = StrictementInferieurSBSB;i++;
				aTABFonction[i] = StrictementInferieurSBSI;i++;
				aTABFonction[i] = StrictementInferieurSBSD;i++;
				aTABFonction[i] = StrictementInferieurSBSF;i++;
				aTABFonction[i] = StrictementInferieurSBSL;i++;

				aTABFonction[i] = StrictementInferieurSBLB;i++;
				aTABFonction[i] = StrictementInferieurSBLI;i++;
				aTABFonction[i] = StrictementInferieurSBLD;i++;
				aTABFonction[i] = StrictementInferieurSBLF;i++;
				aTABFonction[i] = StrictementInferieurSBLL;i++;

				aTABFonction[i] = StrictementInferieurLBSB;i++;
				aTABFonction[i] = StrictementInferieurLBSI;i++;
				aTABFonction[i] = StrictementInferieurLBSD;i++;
				aTABFonction[i] = StrictementInferieurLBSF;i++;
				aTABFonction[i] = StrictementInferieurLBSL;i++;

				aTABFonction[i] = StrictementInferieurLBLB;i++;
				aTABFonction[i] = StrictementInferieurLBLI;i++;
				aTABFonction[i] = StrictementInferieurLBLD;i++;
				aTABFonction[i] = StrictementInferieurLBLF;i++;
				aTABFonction[i] = StrictementInferieurLBLL;i++;
				aTABFonction[i] = NULL;
				return aTABFonction;
			}
		case TOP_STRICT_SUP: //Operateur '>'
			{
				aTABFonction = new PFUNCTION[TV_LAST*4];
				aTABFonction[i] = StrictementSuperieurSBSB;i++;
				aTABFonction[i] = StrictementSuperieurSBSI;i++;
				aTABFonction[i] = StrictementSuperieurSBSD;i++;
				aTABFonction[i] = StrictementSuperieurSBSF;i++;
				aTABFonction[i] = StrictementSuperieurSBSL;i++;

				aTABFonction[i] = StrictementSuperieurSBLB;i++;
				aTABFonction[i] = StrictementSuperieurSBLI;i++;
				aTABFonction[i] = StrictementSuperieurSBLD;i++;
				aTABFonction[i] = StrictementSuperieurSBLF;i++;
				aTABFonction[i] = StrictementSuperieurSBLL;i++;

				aTABFonction[i] = StrictementSuperieurLBSB;i++;
				aTABFonction[i] = StrictementSuperieurLBSI;i++;
				aTABFonction[i] = StrictementSuperieurLBSD;i++;
				aTABFonction[i] = StrictementSuperieurLBSF;i++;
				aTABFonction[i] = StrictementSuperieurLBSL;i++;

				aTABFonction[i] = StrictementSuperieurLBLB;i++;
				aTABFonction[i] = StrictementSuperieurLBLI;i++;
				aTABFonction[i] = StrictementSuperieurLBLD;i++;
				aTABFonction[i] = StrictementSuperieurLBLF;i++;
				aTABFonction[i] = StrictementSuperieurLBLL;i++;
				aTABFonction[i] = NULL;
				return aTABFonction;
			}
		case TOP_INF_OU_EGAL: //Operateur '<='
			{
				aTABFonction = new PFUNCTION[TV_LAST*4];
				aTABFonction[i] = InferieurOuEgalSBSB;i++;
				aTABFonction[i] = InferieurOuEgalSBSI;i++;
				aTABFonction[i] = InferieurOuEgalSBSD;i++;
				aTABFonction[i] = InferieurOuEgalSBSF;i++;
				aTABFonction[i] = InferieurOuEgalSBSL;i++;

				aTABFonction[i] = InferieurOuEgalSBLB;i++;
				aTABFonction[i] = InferieurOuEgalSBLI;i++;
				aTABFonction[i] = InferieurOuEgalSBLD;i++;
				aTABFonction[i] = InferieurOuEgalSBLF;i++;
				aTABFonction[i] = InferieurOuEgalSBLL;i++;

				aTABFonction[i] = InferieurOuEgalLBSB;i++;
				aTABFonction[i] = InferieurOuEgalLBSI;i++;
				aTABFonction[i] = InferieurOuEgalLBSD;i++;
				aTABFonction[i] = InferieurOuEgalLBSF;i++;
				aTABFonction[i] = InferieurOuEgalLBSL;i++;

				aTABFonction[i] = InferieurOuEgalLBLB;i++;
				aTABFonction[i] = InferieurOuEgalLBLI;i++;
				aTABFonction[i] = InferieurOuEgalLBLD;i++;
				aTABFonction[i] = InferieurOuEgalLBLF;i++;
				aTABFonction[i] = InferieurOuEgalLBLL;i++;
				aTABFonction[i] = NULL;i++;
				return aTABFonction;
			}
		case TOP_INF_OU_EGAL: //Operateur '>='
			{
				aTABFonction = new PFUNCTION[TV_LAST*4];
				aTABFonction[i] = SuperieurOuEgalSBSB;i++;
				aTABFonction[i] = SuperieurOuEgalSBSI;i++;
				aTABFonction[i] = SuperieurOuEgalSBSD;i++;
				aTABFonction[i] = SuperieurOuEgalSBSF;i++;
				aTABFonction[i] = SuperieurOuEgalSBSL;i++;

				aTABFonction[i] = SuperieurOuEgalSBLB;i++;
				aTABFonction[i] = SuperieurOuEgalSBLI;i++;
				aTABFonction[i] = SuperieurOuEgalSBLD;i++;
				aTABFonction[i] = SuperieurOuEgalSBLF;i++;
				aTABFonction[i] = SuperieurOuEgalSBLL;i++;

				aTABFonction[i] = SuperieurOuEgalLBSB;i++;
				aTABFonction[i] = SuperieurOuEgalLBSI;i++;
				aTABFonction[i] = SuperieurOuEgalLBSD;i++;
				aTABFonction[i] = SuperieurOuEgalLBSF;i++;
				aTABFonction[i] = SuperieurOuEgalLBSL;i++;

				aTABFonction[i] = SuperieurOuEgalLBLB;i++;
				aTABFonction[i] = SuperieurOuEgalLBLI;i++;
				aTABFonction[i] = SuperieurOuEgalLBLD;i++;
				aTABFonction[i] = SuperieurOuEgalLBLF;i++;
				aTABFonction[i] = SuperieurOuEgalLBLL;i++;
				aTABFonction[i] = NULL;i++;
				return aTABFonction;
			}
		case TOP_INF_OU_EGAL: //Operateur '>='
			{
				aTABFonction = new PFUNCTION[TV_LAST*4];
				aTABFonction[i] = EgalSBSB;i++;
				aTABFonction[i] = EgalSBSI;i++;
				aTABFonction[i] = EgalSBSD;i++;
				aTABFonction[i] = EgalSBSF;i++;
				aTABFonction[i] = EgalSBSL;i++;

				aTABFonction[i] = EgalSBLB;i++;
				aTABFonction[i] = EgalSBLI;i++;
				aTABFonction[i] = EgalSBLD;i++;
				aTABFonction[i] = EgalSBLF;i++;
				aTABFonction[i] = EgalSBLL;i++;

				aTABFonction[i] = EgalLBSB;i++;
				aTABFonction[i] = EgalLBSI;i++;
				aTABFonction[i] = EgalLBSD;i++;
				aTABFonction[i] = EgalLBSF;i++;
				aTABFonction[i] = EgalLBSL;i++;

				aTABFonction[i] = EgalLBLB;i++;
				aTABFonction[i] = EgalLBLI;i++;
				aTABFonction[i] = EgalLBLD;i++;
				aTABFonction[i] = EgalLBLF;i++;
				aTABFonction[i] = EgalLBLL;i++;
				aTABFonction[i] = NULL;i++;
				return aTABFonction;
			}
		default: return aTABFonction;
	}
}