#ifndef PILE_H
#define PILE_H

typedef struct SPile
{
        void *PInfo;
        struct SPile *Prec;
}SPile;

template <class T> class Pile
{
	protected:
		SPile *mCourant;
	public:
		Pile(){ mCourant=NULL;};
		Pile(Pile &pile);
		void Empiler(T info); 				// Permet d'ajouter un element T 
		void Depiler(T &info);				// Renvoye le premier elmt de la pile
		T Get(){return *((T*)(mCourant->PInfo));};	//& de l'element courant
		int Occurrence();
		int Vide(){return (!(int)mCourant);};
		Pile & operator=(Pile &pile);
		~Pile();
};

template <class T> Pile<T>::Pile(Pile &pile)
{
        SPile *Ptr=pile.mCourant,*P,*M;
        T *PtrInfo;
        mCourant=NULL;
        while (Ptr)
        {
                P=new SPile;
                PtrInfo = new T;
                *PtrInfo = *((T*)(Ptr->PInfo));
                P->PInfo = (void *)PtrInfo;
                Ptr=Ptr->Prec;
                if (!mCourant)
                {
                        mCourant=P;
                        P->Prec=NULL;
                } else M->Prec=P;
                M=P;
        }
}

template <class T> void Pile<T>::Empiler(T info)
{
       SPile *P;
       T *ptr=new T;
       P=mCourant;
       mCourant=new SPile;
       mCourant->Prec=P;
       *ptr=info;
       mCourant->PInfo=(void *)ptr;
}

template <class T> void Pile<T>::Depiler(T &info)
{
        if (mCourant)
        {
                SPile *P;
                info=*((T*)(mCourant->PInfo));
        	P=mCourant;  mCourant=mCourant->Prec;
        	delete P->PInfo; delete P;
        }
}

template <class T> Pile<T> & Pile<T>::operator=(Pile &pile)
{
        Pile p(pile);
        return p;
}

template <class T> int Pile<T>::Occurrence()
{
        int Nbre = 0;
        SPile *Ptr = mCourant;
        
        while (Ptr)
        {
                Ptr = Ptr->Prec;
                Nbre++;
        }
        return Nbre;
}
                                        
template <class T> Pile<T>::~Pile()
{
        SPile *P;
        while (mCourant)
        {
                P=mCourant;
                mCourant=mCourant->Prec;
        	delete P->PInfo; delete P;
        }
}
#endif       /*	PILE_H	*/