#include <stdlib.h>
#include <stdio.h>
#include <XMCore.h>
#include <pthread.h>
#include <Communication.h>
#include <Assistant.h>
#include <ToolsXMProtocol.h>
#include <VGlobale.h>
#define  NOM_FICHIER_INPUT	"input.conf"

/*****************************************************************/
/*****************************************************************/
/**			Fonction principale			**/
/*****************************************************************/
/*****************************************************************/

static int gStopServer=0;
int ChargerParametreDeConfiguration();
void CleanFlux();

int main(int argc, char *argv)
{
	XMQuery *pQuery;
	FILE *pFile;
	
	
	atexit(CleanFlux);
	printf("Initialising server ....\n");
	CleanFlux();
	if (!ChargerParametreDeConfiguration()) exit(0);
	printf("Server XMCore started .........\n");
	CreerFluxCommunication(-1, GetPipeClient(ConnectClientToServer()->mID));
	while (!gStopServer)
	{
		if (pQuery = ReadQueryFromClient())
			 Dispatche(pQuery);
	}
	DisconnectClientToServer(-1);
	return 0;
}
/****************************************************************/
/****************************************************************/

int Dispatche(XMQuery *pQuery)
{
	pthread_t thread;
	pthread_attr_t pthread_attr;
	XMSender *sender;
	int k;
	
	sender = new XMSender;
	sender->Set(NULL, pQuery, k);
	pthread_attr_init(&pthread_attr);
	pthread_create (&thread, &pthread_attr, TraiterRequete, sender);
	return thread;
}

void *TraiterRequete(void *sender)
{
	if (!sender) return NULL;
	CFile<XMReponse *> *fReponse=NULL;
	
	XMReponse *pReponse = NULL;
	
	XMQuery *query	= ((XMSender * )sender)->mQuery;
	XMPipe  *pipe	= GetPipeClient(query->IDClient);
	
	switch (query->IDQuery)
	{
		case CQUNKNOWN:
			{
				fReponse=new CFile<XMReponse *>;
				pReponse = InitReponse(new XMReponse);
				printf("[%d] Message inconnu [%d]\n", query->IDClient, CQUNKNOWN);
				pReponse->IDClient = query->IDClient;
				fReponse->Enfiler(pReponse);
			}break;
		case CQCONNECTION:
			{
				SCConnection *acon;
				fReponse=new CFile<XMReponse *>;
				pReponse = InitReponse(new XMReponse);
        			acon = ConnectClientToServer();
        			printf("[%d] Message demande connexion [%d]\n", acon->mID, CQCONNECTION);
				pReponse->IDClient = acon->mID;
				pReponse->IDReponse = XMRCONNECTION;
				CreerFluxCommunication(acon->mID, GetPipeClient(acon->mID));
				fReponse->Enfiler(pReponse);
				
			}break;
		case CQDECONNECTION:
			{
				SCConnection *acon;
				fReponse=new CFile<XMReponse *>;
				pReponse = InitReponse(new XMReponse);
				DisconnectClientToServer(query->IDClient);
        			pReponse->IDClient = query->IDClient;
				pReponse->IDReponse = XMRDECONNECTION;
				gStopServer = 1;
				fReponse->Enfiler(pReponse);
			}break;
		case CQSHUTDOWN:
			{
				fReponse=new CFile<XMReponse *>;
				pReponse = InitReponse(new XMReponse);
        			pReponse->IDClient = query->IDClient;
				pReponse->IDReponse = XMRSHUTDOWN;
				gStopServer = 1;
				fReponse->Enfiler(pReponse);				
			}break;
		case CQSCRIPT:
			{
				char *aQuery;
        			printf("[%d] Message requete maths\n", query->IDClient);
				fReponse = (CFile<XMReponse *> *)SendToAssistant(query->IDClient, GetField(query->Query, 1, 1));
			}break;
		case CQFCN_TOTO:
			break;
		default:
			break;
	}
	delete (sender);
	printf("SERVER>> %d\n", SendFileReponseToClient(pipe, fReponse));
	return NULL;
}

int ChargerParametreDeConfiguration()
{
	FILE *pFile;
	char *Parametre;
	
	if (!(pFile = OuvrirFichierConf(NOM_FICHIER_INPUT))) return 0;
	if (!(Parametre = LireParametreFichierConf(pFile, "TARGET_CONFIG", "CHEMIN_FICHIER_CONFIG"))) return 0;
	FermerFichierConf(pFile);
	if (!(pFile = OuvrirFichierConf(Parametre))) return 0; delete Parametre;
	if (!(Parametre = LireParametreFichierConf(pFile, "FLUX", "FLUX_DIR"))) return 0;
	SetVGlobale(VG_CANAL_FLUX, Parametre);
	return 1;
}

void CleanFlux()
{
	char com[1000];
	if (!GetVGlobale(VG_CANAL_FLUX)) return;
	sprintf(com, "rm %s/XMCorePipe*", GetVGlobale(VG_CANAL_FLUX));
	system(com);
}

class XMObjectX * GetObjectX(char *){}