#include <stdio.h>
#include <type.h>

class XMValueX;

bool TABComparateurExecStrictementInferieur(XMValueX *val1, XMValueX *val2);
bool TABComparateurExecStrictementSuperieur(XMValueX *val1, XMValueX *val2);
bool TABComparateurExecInferieurOuEgal(XMValueX *val1, XMValueX *val2);
bool TABComparateurExecSuperieurOuEgal(XMValueX *val1, XMValueX *val2);
bool TABComparateurExecEgal(XMValueX *val1, XMValueX *val2);

class XMValueX
{
	TValueX mType;
	int mSignificatif;
	void *mValue;
protected:
	bool InitialiserValue(TValueX type, void *val);
public:
	XMValueX();
	XMValueX(TValueX type, int significatif = XM_DEFAULT_SIGNIFICATIF);
	XMValueX operator= (XMValueX valx);
	XMValueX operator= (long val);
	XMValueX operator= (long long val);
	XMValueX operator= (int val);
//	XMValueX operator= (long int val);
	XMValueX operator= (float val);
//	XMValueX operator= (long float val);
	XMValueX operator= (double val);
	XMValueX operator= (long double val);
	
	// Oprateur d'opartion
	XMValueX operator+(XMValueX valx);
	XMValueX operator-(XMValueX valx);
	XMValueX operator*(XMValueX valx);
	XMValueX operator/(XMValueX valx);
	
	// Oprateur de comparaison
	bool operator<(XMValueX valx);
	bool operator>(XMValueX valx);
	bool operator<=(XMValueX valx);
	bool operator>=(XMValueX valx);
	bool operator==(XMValueX valx);
	void SetValue(TValueX type, void *val);
	
	char *GetFormat();
	void *GetValue();
	
	TValueX GetType();	
	void ConvertTo(TValueX tval);
};