#ifndef ARBRE
#define ARBRE
#include <stdio.h>
#include <assert.h>

typedef struct SNoeud
{
        void * Info;
        struct SNoeud *Pere;
        struct SNoeud *Filsg;
        struct SNoeud *Filsd;
}SNoeud;


template <class T> class Arbre
{
        protected:
        SNoeud *mTete;
        SNoeud *mCourant;
        void (*FONCTIONCALL)();
        void Create(Arbre <T> arbre);
        
        public:
        void Init(void *F){FONCTIONCALL=((void (*)())F);};
        Arbre();
        Arbre(Arbre <T> &arbre);
        Arbre & operator =(Arbre & arbre);
        void Detruire();
        void AllerGauche(T &Info);
        void AllerDroite(T &Info);
        void AllerPere(T &Info);
        void AllerTete(T &Info);
        void AjoutDroite(T Info);
        void AjoutGauche(T Info);
        void PermutGauche(T Info);
        /*void PermutDroite(T Info);*/
        void EffacerDroite();
        void EffacerGauche();
        int ExisteDroite();
        int ExisteGauche();
        int ExisteTete();
        int DelTop(T Info);
        int DelTete();
        /*int DelBottom(T Info);*/
        virtual ~Arbre();
        DestrucBis();
};

template <class T> Arbre <T>::Arbre()
{
        mTete=mCourant=NULL;
}

template <class T> Arbre<T>::Arbre(Arbre <T> &arbre)
{
        mTete=mCourant=NULL;
        *this=Liste;
}

template <class T> Arbre<T> & Arbre<T>::operator = (Arbre <T> &arbre)
{
        if (arbre.ExisteTete())
        {
                T Info;
                
                AllerTete(Info);
                AjouterDroite(Info);
                if (arbre.ExisteDroite()
                {
                        arbre.AllerDroite(Info);
                        AjouterDroite(Info);
                        Create(arbre);
                        arbre.AllerPere(Info);
                }
                if (arbre.ExisteGauche()
                {
                        arbre.AllerGauche(Info);
                        AjouterGauche(Info);
                        Create(arbre);
                        arbre.AllerPere(Info);
                }
        }
}

template <class T> void Arbre<T>::Create(Arbre <T> arbre)
{
        SNoeud Info;
        if (arbre.ExisteDroite())
        {
                arbre.AllerDoite(Info);
                AjoutDroite(Info);
                Create(arbre);
                arbre.AllerPere(Info)
        }
        if (arbre.ExisteGauche())
        {
                arbre.AllerGauche(Info);
                AjoutGauche(Info);
                Create(arbre);
                arbre.AllerPere(Info)
        }
}

template <class T> void Arbre<T>::AllerGauche(T &Info)
{
        mCourant= mCourant->Filsg;
        (T)Info= (T)(*mCourant->Info);
}

template <class T> void Arbre<T>::AllerDroite(T &Info)
{
        mCourant= mCourant->Filsd;
        (T)Info= (T)(*mCourant->Info);
}

template <class T> void Arbre<T>::AllerPere(T &Info)
{
        mCourant= mCourant->Pere;
        (T)Info= (T)(*mCourant->Info);
}

template <class T> void Arbre<T>::AllerTete(T &Info)
{
        mCourant= mTete;
        (T)Info= (T)(*mCourant->Info);
}


template <class T> void Arbre<T>::AjoutGauche(T Info)
{
        SNoeud *PSNoeu= new SNoeud;/* La nouvelle cellule */
        T *PtrInfo=new T;
        assert(PSNoeu!=NULL);
        assert(PtrInfo!=NULL);
        PSNoeu->Pere=mCourant;
        ((T *)PSNoeu->Info)= PtrInfo;
        *((T *)PSNoeu->Info)=Info;
        PSNoeu->Filsg= NULL;
        PSNoeu->Filsd= NULL;
        mCourant= PSNoeu;
        if (mTete==NULL) mTete=mCourant; else mCourant->Filsg= PSNoeu;
}
        
template <class T> void Arbre<T>::AjoutDroite(T Info)
{
        SNoeud *PSNoeu= new SNoeud;/* La nouvelle cellule */
        T *PtrInfo=new T;
        assert(PSNoeu!=NULL);
        assert(PtrInfo!=NULL);
        PSNoeu->Pere=mCourant;
        ((T *)PSNoeu->Info)= PtrInfo;
        *((T *)PSNoeu->Info)=Info;
        PSNoeu->Filsg= NULL;
        PSNoeu->Filsd= NULL;
        if (mTete==NULL) mTete=PSNoeu; else mCourant->Filsd= PSNoeu;        
        mCourant= PSNoeu;
}

template <class T> void Arbre<T>::PermutGauche(T Info)
{
        PSNoeu=new SNoeud;
        PSNoeu->Pere=mCourant->Pere;
        (T *)(PSNoeu->Info)=new T;
        *((T *)(PSNoeu->Info)=Info;
        PSNoeu->Filsg= mCourant;
        PSNoeu->Filsd= NULL;
        mCourant->Pere->Fild= PSNoeu;
        mCourant->Pere= PSNoeu;
        mCourant=PSNoeu;
}

template <class T> void Arbre<T>::EffacerGauche()
{
        delete(mCourant->Filsg);
        mCourant->Filsg=NULL;
}

template <class T> void Arbre<T>::EffacerDroite()
{
        delete(mCourant->Filsd);
        mCourant->Filsd=NULL;
}

template <class T> int Arbre<T>::ExisteGauche()
{
        if (mCourant->Filsg==NULL) return 0;else return 1;
}

template <class T> int Arbre<T>::ExisteDroite()
{
        if (!mCourant->Filsd) return 0;else return 1;
}

template <class T> int Arbre<T>::ExisteTete()
{
        if (!mTete) return 0;else return 1;
}

template <class T> void Arbre<T>::Detruire()
{
        if (mCourant)
        {
                SNoeud *P=mCourant;
                if (mCourant->Filsd)
                {
                        mCourant=mCourant->Filsd;
                        (*FONCTIONCALL)();
                        mCourant= P;
                        delete((T *)(mCourant->Filsd->Info));
                        delete(mCourant->Filsd);
                        mCourant->Filsd=NULL;
                }
                if (mCourant->Filsg)
                {
                        mCourant=mCourant->Filsg;
                        (*FONCTIONCALL)();
                        mCourant= P;
                        delete((T *)(mCourant->Filsg->Info));
                        delete(mCourant->Filsg);
                        mCourant->Filsg=NULL;
                }
        }
}

template <class T> int Arbre<T>::DelTop(T Info)
{
        SNoeud *P;
        P= mCourant;
        while (((T)((T *)*P->Info)!=Info) && (P)) P=P->Pere;
        if (!P) return 0;
        if ((!P->Filsd) || (!P->Filsg)) return 0;
        P->Pere->Filsd=P->Filsd;
        P->Filsd->Pere=P->Pere;
        delete(P->Info);
        delete(P);
        return 1;
}

template <class T> int Arbre<T>::DelTete()
{
        if (Tete)
        {
                SNoeud *PSNoeu;
                int Done=0;
                PSNoeu=mTete;
                if ((mTete->Filsd) && (!mTete->Filsg))
                {
                        Done=1;
                        mTete->Filsd->Pere=NULL;
                        mTete=mTete->Filsd;
                }; else
                if ((mTete->Filsg) && (!mTete->Filsd))
                {
                        Done=1;
                        mTete->Filsg->Pere= NULL;
                        mTete=mTete->Filsg;
                }
                if (done)
                {
                        delete((T *)(PSNoeu->Info));
                        delete(PSNoeu);
                        return 1;
                }
         }return 0;
}
                 
                                                   
template <class T> Arbre<T>::~Arbre()
{
        if (mTete)
        {
                mCourant=mTete;
                if (mCourant->Filsd)
                {
			mCourant=mCourant->Filsd;
                        DestrucBis();
                        mCourant=mCourant->Pere;
                }
                if (mCourant->Filsg)
                {
			mCourant=mCourant->Filsg;
                        DestrucBis();
                        mCourant=mCourant->Pere;
		}
		Detruire();
		(*FONCTIONCALL)();
		delete((T *)(mTete->Info));
	        delete mTete;
      	}
}

template <class T> Arbre<T>::DestrucBis()
{
        if (mCourant->Filsd)
        {
                mCourant= mCourant->Filsd;
                DestrucBis();
                mCourant=mCourant->Pere;
        }
        if (mCourant->Filsg)
        {
                mCourant= mCourant->Filsg;
                DestrucBis();
                mCourant=mCourant->Pere;
        }
        Detruire();
}

#endif