#include <stdio.h>
#include "loi.h"
#include "mobjectx.h"

void *GetTAB(OnState st=ON_COMPILE)
{
	return MAINTABOP[st];
}

void InitMainTab(OnState st=ON_COMPILE)
{
	typedef XMObjectX XY;
	if (st == ON_COMPILE) typedef SObjectX XY;
        for (int i=BEGINOFTAB; i<ENDOFTAB; i++)  ((CCalculator<XY> ****)MAINTABOP[st])[i-OFFSET] = NULL;
}

TObjectX GetTypeOBjectX(OnState st, TOperator op, TObjectX lig, TObjectX col)
{
	typedef XMObjectX XY;
	if (st == ON_COMPILE) typedef SObjectX XY; else typedef XMObjectX XY;
	return ((CCalculator<XY> ****)MAINTABOP[st])[op-OFFSET][col][lig]->GetTypeObject();
}

void CreateTABOperator(OnState st, TOperator op)
{
	int i,j;
	typedef XMObjectX XY;
	if (st == ON_COMPILE) typedef SObjectX XY;
	CCalculator<XY> ***aTab = new (CCalculator<XY> **)[DIM_TAB];
	for(i=0;i<DIM_TAB;i++) aTab[i] = new (CCalculator<XY> *)[DIM_TAB];
	for(j=0;j<DIM_TAB;j++) for(int i=0;i<DIM_TAB;i++) aTab[j][i] = NULL;
	((CCalculator<XY> ****)MAINTABOP[st])[op-OFFSET] = aTab;
        for(j=0;j<DIM_TAB; j++) for(i = 0; i<DIM_TAB; i++)	((CCalculator<XY> ****)MAINTABOP[st])[op-OFFSET][j][i] = NULL;
}

void RemoveCalculator(OnState st, TOperator op, TObjectX lig, TObjectX col)
{
	typedef XMObjectX XY;
	if (st == ON_COMPILE) typedef SObjectX XY;
        if (((CCalculator<XY> ****)MAINTABOP[st])[op-OFFSET])
        {
        	if (((CCalculator<XY> ****)MAINTABOP[st])[op-OFFSET][col][lig])
        	       delete (((CCalculator<XY> ****)MAINTABOP[st])[op-OFFSET][col][lig]);
        }
        ((CCalculator<XY> ****)MAINTABOP[st])[op-OFFSET][col][lig] = NULL;
}

void RemoveTABOperator(OnState st, TOperator op)
{
        typedef XMObjectX XY;
	if (st == ON_COMPILE) typedef SObjectX XY;
        if (((CCalculator<XY> ****)MAINTABOP[st])[op-OFFSET])
        {
                int i;
                for (int j = 0; j<DIM_TAB; j++)
                	for (i=0; i<DIM_TAB; i++)
                		RemoveCalculator(st, op,(TObjectX)i,(TObjectX)j);
                delete (((CCalculator<XY> ****)MAINTABOP[st])[op-OFFSET]);
        	((CCalculator<XY> ****)MAINTABOP[st])[op-OFFSET] = NULL;
        }
}