#ifndef LOI_H
#define LOI_H
#include "type.h"
#include "calculator.h"

#define DIM_TAB	TO_UNKNOWN+1
#define OFFSET	(TO_UNKNOWN+1)
#define BEGINOFTAB	OFFSET
#define ENDOFTAB	TOP_LAST

typedef CCalculator<SObjectX>  *TABOperatorC[DIM_TAB][DIM_TAB];
typedef CCalculator<XMObjectX> *TABOperatorR[DIM_TAB][DIM_TAB];

static TABOperatorC *MainTABOpC[TOP_LAST-OFFSET];
static TABOperatorR *MainTABOpR[TOP_LAST-OFFSET];
static void *MAINTABOP[]={MainTABOpC, MainTABOpR, 0};

void *GetTAB(OnState st=ON_COMPILE);

void InitMainTab(OnState st=ON_COMPILE);
void CreateTABOperator(OnState st, TOperator op);
void RemoveTABOperator(OnState st, TOperator op);
void RemoveCalculator(OnState st, TOperator op, TObjectX lig, TObjectX col);
TObjectX GetTypeObjectX(OnState st, TOperator op, TObjectX lig, TObjectX col);
TObjectX GetTypeObjectXByChar(char type);
template <class T> void SetFunctionCalc(OnState st, TOperator op, TObjectX lig, TObjectX col, T* (*fcalc)(T*, T*));
template <class T> void SetCalculator(OnState st, TOperator op, TObjectX lig, TObjectX col, CCalculator<T> *pcal);
template <class T> T* GetResult(OnState st, TOperator op, T *objlig, T *objcol);
template <class T> CCalculator<T> *GetCalculator(OnState st, TOperator op, TObjectX lig, TObjectX col);


template <class T> T* GetResult(OnState st, TOperator op, T *objlig, T *objcol)
{
        TObjectX type;
        if (!objlig) type = TO_INIT; else type = objlig->Type();
        return ((CCalculator<T> ****)GetTAB(st))[op-OFFSET][objcol->Type()][type]->Evaluate(st,objlig, objcol);
}

template <class T>CCalculator<T> *GetCalculator(OnState st, TOperator op, TObjectX lig, TObjectX col)
{
        return ((CCalculator<T> ****)GetTAB(st))[op-OFFSET][col][lig];
}

template <class T> void SetCalculator(OnState st, TOperator op, TObjectX lig, TObjectX col, CCalculator<T> *pcal)
{
        ((CCalculator<T> ****)GetTAB(st))[op-OFFSET][col][lig] = pcal;
}

template <class T> void SetFunctionCalc(OnState st, TOperator op, TObjectX lig, TObjectX col, T* (*fcalc)(T*, T*))
{
        ((CCalculator<T> ****)GetTAB(st))[op-OFFSET][col][lig]->SetfCalc(fcalc);
}

#endif	/* LOI_H */