#include "mobjectx.h"

XMObjectX *GetXMObjectX(char *name, CList<XMObjectX *> *list=NULL)
{
	XMObjectX *ob = NULL;
	if (ob = GetObjectX(name)) return ob;
	if (!list) return ob;
	for (list->MoveFirst(ob);!list->Eol();list->MoveNext(ob)) if (ob->GetName()) if (!strcmp(ob->GetName(),name)) return ob;
	return NULL;
}

XMObjectX::XMObjectX()
{
	mObjectX = NULL;
        mExpression[0] = mExpression[1] = mName = NULL;
        mLVar = NULL;
        mType = TO_UNKNOWN;
}


XMObjectX::XMObjectX(XMObjectX &obj)
{
	mObjectX = NULL;
        mExpression[0] = (obj.mExpression[1]?Copie(0,strlen(obj.mExpression[0]),obj.mExpression[0]):NULL);
        mExpression[1] = (obj.mExpression[1]?Copie(0,strlen(obj.mExpression[1]),obj.mExpression[1]):NULL);
        mName = (obj.mName?Copie(0, strlen(obj.mName), obj.mName):NULL);
        mLVar = (obj.mLVar?new CList<XMObjectX *>(*obj.mLVar):NULL);
        mType = obj.mType;
}

XMObjectX::XMObjectX(XMObjectX *obj)
{
	mObjectX = NULL;
        mExpression[0] = (obj->mExpression[0]?Copie(0,strlen(obj->mExpression[0]),obj->mExpression[0]):NULL);
        mExpression[1] = (obj->mExpression[1]?Copie(0,strlen(obj->mExpression[1]),obj->mExpression[1]):NULL);
	mName = (obj->mName?Copie(0, strlen(obj->mName), obj->mName):NULL);
        mLVar = (obj->mLVar?new CList<XMObjectX *>(*(obj->mLVar)):NULL);
        mLVar = (obj->mLVar?new CList<XMObjectX *>(*obj->mLVar):NULL);
        mType = obj->mType;
}

XMObjectX::XMObjectX(char *expi, char *expe=NULL, char *nom=NULL)
{
	mObjectX = NULL;
	mExpression[0] = (expi?Copie(0,strlen(expi),expi):NULL);
	mExpression[1] = (expi?Copie(1,strlen(expi),expi):NULL);
	mName = (nom?Copie(0,strlen(nom),nom):NULL);
        mLVar = NULL;
        mType = TO_UNKNOWN;
}

void XMObjectX::SetName(char *Name)
{
	if (mName) delete mName;
	mName = (Name?Copie(0, strlen(Name), Name):NULL);
}

void XMObjectX::SetExp(int k, char *exp)
{
	int i;
	if (mExpression[k]) delete mExpression[k];
	mExpression[k] = NULL;
        if (!exp) return;
        if (exp[strlen(exp)-1]!=';') i=((k)?0:1); else i=k;
        mExpression[k] = Copie(0, strlen(exp)+i, exp);
        if ((i) && (!k)) strcat(mExpression[k], ";");
        if (k) (mExpression[1])[strlen(mExpression[1])-i] = '\0';
}

char *XMObjectX::GetName()
{
        return mName;
}

char *XMObjectX::GetExp(int k)
{
        return mExpression[k];
}

void XMObjectX::AddVariable(XMObjectX *obj)
{
	if (!mLVar) mLVar = new CList<XMObjectX *>;
	mLVar->Add(obj);
}

void XMObjectX::AddVariables(CList<XMObjectX *> *lvar)
{
	if (!lvar) return;
	XMObjectX *ob;
	for(lvar->MoveFirst(ob); !lvar->Eol(); lvar->MoveNext(ob)) AddVariable(ob);
}

int XMObjectX::NVariables()
{
	return (mLVar?mLVar->GetCount():0);
}

void *XMObjectX::Variables()
{
	return (mLVar?mLVar:0);
}

XMObjectX *XMObjectX::Variable(int k)
{
	if (!mLVar) return NULL;
	if ((k<0) && (k>=mLVar->GetCount())) return NULL;
	return mLVar->Get(k);
}

XMObjectX *XMObjectX::Variable(char *name)
{
	if (!mLVar) return NULL;
	if (!name) return NULL;
	XMObjectX *obj = NULL;
	for (mLVar->MoveFirst(obj);!mLVar->Eol(); mLVar->MoveNext(obj))
	{
		if (!obj->GetName()) continue;
		if (!strcmp(obj->GetName(), name)) return obj;
	}
	return obj;
}

XMObjectX::~XMObjectX()
{
        if (mExpression[0]) delete mExpression[0];
        if (mExpression[1]) delete mExpression[1];
        if (mName) delete mName;
        if (mLVar) delete mLVar;
        mExpression[0] = mExpression[1] = mName = NULL;
        mLVar = NULL;
       	mObjectX = NULL;
}
