#include "ploter.h"

XMPloter::XMPloter()
{
	mType = TO_PLOTER;
	mMethod = NULL;
	mAPloter = NULL ;
	mIntervalles = NULL;
}

XMPloter::XMPloter(char *smeth)
{
	mType = TO_PLOTER;
	TMethod meth=GetTypeMethodFor(smeth);
	if (meth == TM_UNKNOWN) meth = TM_CARTESIAN2D;
	mMethod = GetMethodFor(meth);
	mAPloter = NULL ;
	mIntervalles = NULL;
}

XMPloter::XMPloter(TMethod meth)
{
	mType = TO_PLOTER;
	mMethod = GetMethodFor(meth);
	if (!mMethod) mMethod = GetMethodFor(TM_CARTESIAN2D);
	mAPloter = NULL ;
	mIntervalles = NULL;
}

XMPloter::XMPloter(XMObjectX *ob, TMethod meth=TM_CARTESIAN2D)
{
	mType = TO_PLOTER;
	mMethod = GetMethodFor(meth);
	mIntervalles = NULL;
	mAPloter = new CList<XMObjectX *>;
	mAPloter->Add(ob);
}

XMPloter::XMPloter(TMethod meth, CList<XMObjectX *> *pobj, CList<XMIntervalle *> *inter)
{
	mType = TO_PLOTER;
	mMethod = GetMethodFor(meth);
	mAPloter = pobj;		// Doit terminer par null
	mIntervalles = inter;		// Doit terminer par null
}

void XMPloter::Add(XMObjectX *obj)
{
	if (obj->Type() == TO_INTERVALLE)
	{
		if (!mIntervalles) mIntervalles = new CList<XMIntervalle *>;
		mIntervalles->Add((XMIntervalle *)obj);
	} else
	{
		if (!mAPloter) mAPloter = new CList<XMObjectX *>;
		mAPloter->Add(obj);
	}
}

void *XMPloter::Map(CList <XMObjectX *> *lvar)
{
	XMTRACE("Appelle  Ploter::Map\n");
	return (mMethod?mMethod->Map(mAPloter,lvar):NULL);
}

void XMPloter::SetMethode(TMethod meth)
{
	int n;
	mMethod = GetMethodFor(meth);
}

int XMPloter::Dim()
{
	return mMethod->Dim();
}

CList <XMIntervalle *> *XMPloter::Intervalles()
{
	return mIntervalles;
}

XMMethodPlot * XMPloter::Method()
{
	return mMethod;
}

TYPE ** XMPloter::Reach(int &vld, TYPE **pt, TYPE **Res)
{
	//mMethod->Reach(vld, mAPloter, pt, Res);
	return Res;
}

void  XMPloter::Lecture()
{
	XMTRACE("==========  Lecture de l'objet XMPloter =============\n");
	XMTRACE("Type: %d\n", mType);
	if (mMethod)
	{
		XMTRACE("Methode\n");
		XMTRACE(" Type: %d\n", mMethod->Method());
 		XMTRACE(" Dimension: %d\n", mMethod->Dim());
	} else XMTRACE("Methode: Acune!!!\n");
	XMTRACE("Ploter\n");
	if (mAPloter) XMTRACE("Nbre d'objets  tracer: %d\n", mAPloter->GetCount()); else
		XMTRACE("Aucun objet  tracer\n");
	if (mIntervalles) XMTRACE("Nbre d'objets  tracer: %d\n",mIntervalles->GetCount()); else
		XMTRACE("Aucun objet  tracer\n");
	mIntervalles = NULL;
}

XMPloter::~XMPloter()
{
	if (mMethod) delete mMethod;
	if (mAPloter) delete mAPloter;
	if (mIntervalles) delete mIntervalles;
	mMethod = NULL;
	mAPloter = NULL ;
	mIntervalles = NULL;
}