#include "syscoord.h"


SysCoord::SysCoord(XMObjectX *ob)
{
	mType = TO_SYSCOORD;
	mAxes = NULL;
	mDim = 0;
	if (ob->Type() != TO_INTERVALLE) return;
	mAxes = new CList<XMIntervalle *>;
	mAxes->Add((XMIntervalle *)ob);
}

SysCoord::SysCoord(int dim)
{
	mType = TO_SYSCOORD;
	mAxes = NULL;
	mDim = 0;
	if ((dim>3) || (dim<=0)) return;
	mDim = dim;
	mAxes = new CList<XMIntervalle *>;
}

void SysCoord::ConfigureAxe(int no, char *nom, double min=-5, double max=5)
{
	if (mDim>no) mAxes->Add(new XMIntervalle(nom, new XMVariable(NULL,NULL,min), new XMVariable(NULL,NULL,max)));
}

SysCoord::~SysCoord()
{
	if (!mAxes) return;
	delete mAxes;
	mAxes = NULL;
}