#include "vecteur.h"

XMVecteur::XMVecteur()
{
	mType = TO_VECTEUR;
        mDim = 0;
        mVect = NULL;
}

XMVecteur::XMVecteur(XMVecteur &vect)
{
	mType = TO_VECTEUR;
        mDim = vect.mDim;
        mVect = NULL;
        if (!mDim) return;
        mVect = new (XMObjectX*)[mDim];
        for (int i=0; i<mDim; i++) mVect[i] = (vect.mVect[i])->Clone();
}

XMVecteur::XMVecteur(int dim)
{
	mType = TO_VECTEUR;
        mDim = dim;
        if (!mDim) return;
        mVect = new (XMObjectX*)[mDim];
}

void XMVecteur::SetDim(int dim)
{
        mDim = dim;
        if (!mDim) return;
        mVect = new (XMObjectX*)[mDim];
}

int  XMVecteur::GetDim()
{
        return mDim;
}

void XMVecteur::SetCoord(XMObjectX *mobj, int rg)
{
        mVect[rg] = mobj;
}

XMObjectX *XMVecteur::GetCoord(int rg)
{
        return mVect[rg];
}

void XMVecteur::DeleteCoord(int rg)
{
        if (!mVect[rg]) return;
        delete (mVect[rg]);
        mVect[rg] = NULL;
}

XMObjectX *XMVecteur::Clone()
{
        return new XMVecteur(*this);
}

XMObjectX *XMVecteur::Diff(char *x)
{
        XMVecteur *vect;
        char *nom;
        vect = new XMVecteur(mDim);
        nom = new char[strlen(mName)+2];
        sprintf(nom, "%s'", mName);
        vect->SetName(nom);
        for (int i=0; i<mDim; i++) vect->mVect[i] = mVect[i]->Diff(x);
        delete nom;
        return vect;
}

char *XMVecteur::Formatted()
{
	char *formatted;
	char Temp1[200], Temp2[200];
	formatted = new char[1000];
	//for (int j=0; j<m
	sprintf(formatted, "%d#%s#", mType, mName);
	return formatted;
}

void XMVecteur::Lecture()
{
}

char *XMVecteur::Affiche()
{
}

char *XMVecteur::EvalF(int &vld, CList <XMObjectX *> *lvar=NULL)
{
}

TYPE XMVecteur::Eval(int &vld, CList <XMObjectX *> *lvar=NULL)
{
}

XMVecteur::~XMVecteur()
{
        if (!mDim) return;
        for (int i=0; i<mDim; i++) DeleteCoord(i);
        delete mVect;
        mVect = NULL;
	mType = TO_UNKNOWN;
}