#include <xmgthread.h>

void GThreadInit(GThreadFunctions* init)
{
	g_thread_init (init);
}

GThreadAttr *GThreadAttrSetDetachState(GThreadAttr *pthread_attr, GThreadProperty prop=PTHREAD_CREATE_JOINABLE)
{
	pthread_attr_setdetachstate(pthread_attr, prop);
	return (pthread_attr);
}

GThreadAttr *GThreadAttrInit(GThreadAttr *pthread_attr)
{
	pthread_attr_init(pthread_attr);
	return (pthread_attr);
}

GPointer GThreadCreate(GThreadFunction func, GPointer data, GThreadAttr *pthread_attr)
{
	pthread_t thread;
	/* This is the default, it seems, so leave that out for now
	pthread_attr_setdetachstate (&pthread_attr, PTHREAD_CREATE_JOINABLE);
	*/
	if (data) pthread_create (&thread, pthread_attr,  (void *(*)(void *))func, data);
	else pthread_create (&thread, pthread_attr, (void *(*)(void *)) func, data);
	return GUINT_TO_POINTER (thread);
}

void GThreadJoin(GPointer id, GPointer result)
{
	pthread_join((pthread_t)id, &result);
}

void GThreadWait(double seconds)
{
	GMutex *mutex;
	GCond *cond;
	GTimeVal current_time;

	g_get_current_time (&current_time);
	mutex = g_mutex_new ();
	cond = g_cond_new ();

	current_time.tv_sec += (guint) seconds;
	seconds -= (guint) seconds;
	current_time.tv_usec += (guint) (seconds * G_MICROSEC);
	while (current_time.tv_usec >= G_MICROSEC)
	{
		current_time.tv_usec -= G_MICROSEC;
		current_time.tv_sec++;
	}

	g_mutex_lock (mutex);
	g_cond_timed_wait (cond, mutex, &current_time);
	g_mutex_unlock (mutex);

	g_mutex_free (mutex);
	g_cond_free (cond);
}

void GThreadFree(GPointer data)
{
	g_free (data);
}