#! /bin/sh

FICHIER_CONFIG=`dirname $0`/Setup.conf

function AfficherAide ( )
{
	echo "easymaths-config [OPTION]"
	echo "Avec [OPTION]"
	echo "		-h ? --help			affiche ce message"
	echo "		-hm --home			retourne l'emplacement de EasyMaths"
	echo "		-ve --version			retourne la version de l'interface EasyMaths"
	echo "		-vc --versioncore		retourne la version du noyau de EasyMaths"
	echo "		-ihmldir --ihmlibdir		retourne l'emplacement des librairies de l'interface EasyMaths"
	echo "		-ihmidir --ihmincludedir	retourne l'emplacement des headers de l'interface EasyMaths"
	echo "		-coreldir --corelibdir		retourne l'emplacement des librairies de l'interface EasyMaths"
	echo "		-coreidir --coreincludedir	retourne l'emplacement des headers de l'interface EasyMaths"
	echo "		-ihml --ihmlibs			retourne les librairies de l'interface EasyMaths"
	echo "		-ihmc --ihmincludes		retourne les headers de l'interface EasyMaths"
	echo "		-corel --corelibs		retourne les librairies de l'interface EasyMaths"
	echo "		-corec --coreincludes		retourne les headers de l'interface EasyMaths"
	echo "		-n --name			retourne le nom de l'excutable EasyMaths"
}

function ChargerParametre ( )
{
	LIGNE=`grep $1= $FICHIER_CONFIG`
	PARAMETRE_CONFIG=`echo $LIGNE|cut -d= -f2`
}

function ProcedurePrincipale ( )
{
	if [ $# = 0 ]; then
		AfficherAide
	fi
	case $1 in
		?) AfficherAide;;
		-h) AfficherAide;;
		--help) AfficherAide;;
		--name)
			ChargerParametre EASYMATHS_NAME
			echo $PARAMETRE_CONFIG;;
		-n)
			ChargerParametre EASYMATHS_NAME
			echo $PARAMETRE_CONFIG;;
		--home)
			ChargerParametre EASYMATHS_HOME
			echo "$PARAMETRE_CONFIG";;
		-hm)
			ChargerParametre EASYMATHS_HOME
			echo "$PARAMETRE_CONFIG";;
		--version)
			ChargerParametre EASYMATHS_VERSION
			echo "$PARAMETRE_CONFIG";;
		-ve)
			ChargerParametre EASYMATHS_VERSION
			echo "$PARAMETRE_CONFIG";;
		--versioncore)
			ChargerParametre CORE_VERSION
			echo $PARAMETRE_CONFIG;;
		-vc)
			ChargerParametre CORE_VERSION
			echo $PARAMETRE_CONFIG;;
		--ihmlibdir)
			ChargerParametre IHM_LIBRAIRIES_DIR
			echo $PARAMETRE_CONFIG;;
		-ihmldir)
			ChargerParametre IHM_LIBRAIRIES_DIR
			echo $PARAMETRE_CONFIG;;
		--corelibdir)
			ChargerParametre CORE_LIBRAIRIES_DIR
			echo $PARAMETRE_CONFIG;;
		-coreldir)
			ChargerParametre CORE_LIBRAIRIES_DIR
			echo $PARAMETRE_CONFIG;;
		--ihmincludedir)
			ChargerParametre IHM_INCLUDES_DIR
			echo $PARAMETRE_CONFIG;;
		-ihmidir)
			ChargerParametre IHM_INCLUDES_DIR
			echo $PARAMETRE_CONFIG;;
		--coreincludedir)
			ChargerParametre CORE_INCLUDES_DIR
			echo $PARAMETRE_CONFIG;;
		-coreidir)
			ChargerParametre CORE_INCLUDES_DIR
			echo $PARAMETRE_CONFIG;;
		--ihmlibs)
			ChargerParametre IHM_LIBRAIRIES
			echo $PARAMETRE_CONFIG;;
		-ihml)
			ChargerParametre IHM_LIBRAIRIES
			echo $PARAMETRE_CONFIG;;
		--corelibs)
			ChargerParametre CORE_LIBRAIRIES
			echo $PARAMETRE_CONFIG;;
		-corel)
			ChargerParametre CORE_LIBRAIRIES
			echo $PARAMETRE_CONFIG;;
		--ihmincludes)
			ChargerParametre IHM_INCLUDES
			echo $PARAMETRE_CONFIG;;
		-ihmc)
			ChargerParametre IHM_INCLUDES
			echo $PARAMETRE_CONFIG;;
		--coreincludes)
			ChargerParametre CORE_INCLUDES
			echo $PARAMETRE_CONFIG;;
		-ihmc)
			ChargerParametre CORE_INCLUDES
			echo $PARAMETRE_CONFIG;;
	esac
}

ProcedurePrincipale $*
