/*
easymaths Application
Main unit implementation file:easymaths.cc
*/
#include <signal.h>
#include <easymaths.h>
#include <easymaths_signal.h>
#include <VGlobal.h>
#include <Core/xmgthread.h>
#include <string.h>
#include <FichierConf.h>

#define NOM_FICHIER_INPUT	"input.conf"

/*
main program
*/
int main (int argc, char *argv[])
{
	EasymathsApp app(&argc, argv);
        app.Run();
	return 0;
}

// Easymaths MAIN FORM  CLASS
/*
main form constructor
*/
EasymathsForm::EasymathsForm(VDKApplication* app, char* title):
	VDKForm(app,title)
{
	mProgress = NULL;
	mCurrentFile[0] = '\0';
	IsRunning = false;
}

/*
main form destructor
*/
EasymathsForm::~EasymathsForm()
{
}

/*
main form setup
*/
void
EasymathsForm::Setup(void)
{
	GUISetup(); // vdkb gui setup
// put your code below here
        GThreadInit(NULL);
        //SetMemory(new Memory<XMObjectX*, XMObjectX>(MAX_MEMOIRE));
	FILE *pFile;
	char *Parametre;
	
	if (!(pFile = OuvrirFichierConf(NOM_FICHIER_INPUT)))
		Application()->MessageBox("Erreur d'initialisation",
		"Le fichier d'initialisation n'a pas t trouv\n l'emplacement attendu.", MB_OK);
	else
		if (!(Parametre = LireParametreFichierConf(pFile, "TARGET_CONFIG", "CHEMIN_FICHIER_CONFIG")))
			Application()->MessageBox("Erreur de chargement",
				"Le chemin du fichier d'initialisation des parametres n'a pas t trouv.", MB_OK);
	FermerFichierConf(pFile);
	if (!(pFile = OuvrirFichierConf(Parametre)))
	{
		Application()->MessageBox("Erreur de chargement",
		"Le fichier de chargement de donnes de EasyMaths n'a pas t trouv!", MB_OK);
		delete Parametre;
	}
	else
	{
	 	delete Parametre;
		if (!(Parametre = LireParametreFichierConf(pFile, "FLUX", "FLUX_DIR")))
			Application()->MessageBox("Erreur de chargement",
				"Le canal de communication avec le server n'a pas\nt trouv dans le fichier d'initialisation.", MB_OK);
		mConnection = ConnectToServer(Parametre);
		if (mConnection != NULL) ListenToServer(mConnection, 1, this);
		else Application()->MessageBox("Erreur de connection", "Impossible de se connecter au server maintenant", MB_OK);
	}
}

// Easymaths APPLICATION  CLASS
/*
application constructor
*/
EasymathsApp::EasymathsApp(int* argc, char** argv):
	VDKApplication(argc,argv)
{
}

/*
application destructor
*/
EasymathsApp::~EasymathsApp()
{
}

/*
application setup
*/

void
EasymathsApp::Setup(void)
{
	MainForm = new EasymathsForm(this,NULL);
	MainForm->Setup();
	MainForm->Visible = true;
}

void EasymathsForm::UpdateTitle(bool modified)
{
	char indicator[2];
	if (modified == true) sprintf(indicator, "*");
	if (modified == false) sprintf(indicator," ");
	sprintf(mTitle, "%s [%s%s]", mTITLE_VERSION, basename(mCurrentFile), indicator);
	Title = mTitle;
}