#include <Config.h>
#include <easymaths.h>
#include <Pixmaps.h>

/*
defining signal and events
dynamics tables
*/
DEFINE_SIGNAL_LIST(EasymathsForm,VDKForm);
DEFINE_EVENT_LIST(EasymathsForm,VDKForm);
/*
defining signal static table
*/
DEFINE_SIGNAL_MAP(EasymathsForm,VDKForm)
#include <Handlers_Signal.h>
END_SIGNAL_MAP
/*
main form setup
*/
void
EasymathsForm::GUISetup(void)
{
	VDKMenu *menu;
        VDKBox *aBox, *MainBox;
        VDKFrame *aFrame;
        calendardate today;

        //Creation du container principal
        MainBox = new VDKBox(this,v_box);

        sprintf(mTITLE_VERSION, "EasyMaths %s", XM_VERSION);
	mPanelbar = new VDKPanelbar(this,3);
	mPanelbar->Panels()[0]->Caption = mTITLE_VERSION;
	mPanelbar->Panels()[1]->Caption = today.CalendarDate();
	mPanelbar->Panels()[2]->Caption = "I'm never enjoyed";
	Add(mPanelbar, r_justify, FALSE, FALSE, 0);

        // Titre de l'application
        sprintf(mCurrentFile, "%s", "Edit1.xm");
	UpdateTitle(false);

        // Cration de la barre de menu
        mMenubar = new VDKMenubar(this);

        //    Menu "Fichier"
        miMenu0 = new VDKMenuItem(mMenubar,"_Fichier",NULL);
            menu = new VDKMenu(this);
                mMenu000 = new VDKMenuItem(menu,"_Nouveau",NULL);
                mMenu001 = new VDKMenuItem(menu,"_Ouvrir",NULL);
                    menu->Separator();
                mMenu002 = new VDKMenuItem(menu,"_Enregistrer",NULL);
                mMenu003 = new VDKMenuItem(menu,"_Enregistrer sous",NULL);
                    menu->Separator();
                mMenu004 = new VDKMenuItem(menu,"_Conf imprimmante",NULL);
                mMenu005 = new VDKMenuItem(menu,"_Imprimer",NULL);
                mMenu006 = new VDKMenuItem(menu,"_Mise en page",NULL);
                    menu->Separator();
                mMenu007 = new VDKMenuItem(menu,"_Fichiers",NULL);
                	mMenu0070 = new VDKMenu(this);
                		mMenu00700 = new VDKMenuItem(mMenu0070,"_Vider la liste",NULL);
                    	mMenu0070->Separator();
                	mListOldFile = new FileArch(EAS_MAX_FILEOPEN);
                mMenu007->Add(mMenu0070);
                    menu->Separator();
                mMenu008 = new VDKMenuItem(menu,"F_ermer",NULL);
                mMenu009 = new VDKMenuItem(menu,"_Quitter",NULL);
        miMenu0->Add(menu);

        //    Menu "Edition" 
        miMenu1 = new VDKMenuItem(mMenubar,"_Edition",NULL);
            menu = new VDKMenu(this);
                mMenu100 = new VDKMenuItem(menu,"Annuler",NULL);
                mMenu101 = new VDKMenuItem(menu,"Couper",NULL);
                mMenu102 = new VDKMenuItem(menu,"Copier",NULL);
                mMenu103 = new VDKMenuItem(menu,"Coller",NULL);
                    menu->Separator();
                mMenu103 = new VDKMenuItem(menu,"Slectionner tout",NULL);
        miMenu1->Add(menu);

        //    Menu "Bibliothque"
        miMenu2 = new VDKMenuItem(mMenubar,"_Bibliotheque",NULL);
            menu = new VDKMenu(this);
                mMenu200 = new VDKMenuItem(menu,"_Standard",NULL);
                mMenu201 = new VDKMenuItem(menu,"_EasyMaths",NULL);
                mMenu202 = new VDKMenuItem(menu,"_Utilisateur",NULL);
        miMenu2->Add(menu);

        //    Menu "Vue"
        miMenu3 = new VDKMenuItem(mMenubar,"_View",NULL);
            menu = new VDKMenu(this);
                mMenu300 = new VDKMenuItem(menu,"_Plane",NULL);
                mMenu301 = new VDKMenuItem(menu,"_Spaciale",NULL);
        miMenu3->Add(menu);

        //    Menu "Option"
        miMenu4 = new VDKMenuItem(mMenubar,"_Option",NULL);
            menu = new VDKMenu(this);
                mMenu400 = new VDKMenuItem(menu,"_Polices",NULL);
                mMenu401 = new VDKMenuItem(menu,"Conf _Pile",NULL);
                mMenu402 = new VDKMenuItem(menu,"Conf _Graphe",NULL);
        miMenu4->Add(menu);

        //    Menu "Outils"
        miMenu5 = new VDKMenuItem(mMenubar,"Ou_tils",NULL);
            menu = new VDKMenu(this);
                mMenu500 = new VDKMenuItem(menu,"_Latex  document",NULL);
                mMenu501 = new VDKMenuItem(menu,"_Mapple document",NULL);
                mMenu502 = new VDKMenuItem(menu,"_Word   document",NULL);
                mMenu503 = new VDKMenuItem(menu,"_HTML   document",NULL);
                mMenu504 = new VDKMenuItem(menu,"_Text   document",NULL);
        miMenu5->Add(menu);

        //    Menu "Aide"
        miMenu6 = new VDKMenuItem(mMenubar,"_Aide",NULL);
            menu = new VDKMenu(this);
                mMenu600 = new VDKMenuItem(menu,"Index...",NULL);
                mMenu601 = new VDKMenuItem(menu,"Aide Contextuelle...",NULL);
                    menu->Separator();
                mMenu602 = new VDKMenuItem(menu,"Aide  propos...",NULL);
        miMenu6->Add(menu);

        MainBox->Add(new VDKSeparator(this));

        //    Barre d'outils des fonctions systmes
        mToolbar0 = new VDKToolbar(this);
        mToolbar0->AddButton(NEWXPM,  "Nouveau",  "Nouveau");
        mToolbar0->AddSpace();
        mToolbar0->AddButton(OPENXPM, "Ouvrir",   "Ouvrir");
        mToolbar0->AddSpace();
        mToolbar0->AddButton(RUNXPM,  "Excuter", "Excuter");
        mToolbar0->AddSpace();
        mToolbar0->AddButton(KILLXPM, "Quitter", "Quitter");
        mToolbar0->AddSpace();

        MainBox->Add(new VDKSeparator(this));
        MainBox->Add(mToolbar0);

        //    Handle Box pour les fonction mathmatiques
        mHandlebox0 = new VDKHandleBox(this);
		mToolbar1 = new VDKToolbar(this);
		mToolbar1->AddSpace();
		mToolbar1->AddButton(VARIABLEXPM, "Variable",   "x = ");
		mToolbar1->AddSpace();
		mToolbar1->AddButton(INTERVALXPM, "Intervalle", "I = a ... b");
		mToolbar1->AddSpace();
		mToolbar1->AddButton(FUNCTIONXPM, "Fonction",   "f(x) = ");
		mToolbar1->AddSpace();
		mToolbar1->AddButton(SUMXPM,      "Somme",      "sum( )");
		mToolbar1->AddSpace();
		mToolbar1->AddButton(MATRIXXPM,   "Matrice",    "mat([ ])");
		mToolbar1->AddSpace();
		mToolbar1->AddButton(INTEGRALXPM, "Intgral",   "int( , x, a ... b)");
		mToolbar1->AddSpace();
		mToolbar1->AddButton(DERIVATEXPM, "Drive",    "diff( , x)");
		mToolbar1->AddSpace();
		mToolbar1->AddButton(GRAPHXPM,    "Graphe",     "plot({CARTESIAN, }, x = a ...b)");
	mHandlebox0->Add(mToolbar1);
        
        MainBox->Add(mHandlebox0);

        aBox = new VDKBox(this,v_box);
           	mPaned = new VDKPaned(this, v_box);
          		aFrame = new VDKFrame(this, "Input", v_box, shadow_etched_in);
         			mTextin = new VDKText(this, TRUE);
      		    aFrame->Add(mTextin, l_justify, TRUE,TRUE,0);
           	mPaned->Add(aFrame, 1);
      		    aFrame = new VDKFrame(this, "Output", v_box, shadow_etched_in);
 			    mTextout = new VDKText(this, TRUE);
		    aFrame->Add(mTextout,1);
	        mPaned->Add(aFrame, 2);
        aBox->Add(mPaned, 0, TRUE, TRUE, 0);
        MainBox->Add(aBox);

        Add(mMenubar,l_justify,FALSE,FALSE,0);
        Add(MainBox,l_justify,FALSE,FALSE,0);
        SetSize(504, 440);
}

void EasymathsForm::InitialiserMenuFichiers()
{
	mMenu0070 = new VDKMenu(this);
        	mMenu00700 = new VDKMenuItem(mMenu0070,"_Vider la liste",NULL);
        mMenu0070->Separator();
        mMenu007->Add(mMenu0070);
}