#! /bin/sh
#########################################
#		Version.sh		#
#					#
#########################################


## Initialisation des constantes ########
NOM_OUTIL=`basename $0`
BASE_OUTILS=`dirname $0`
FICHIER_CONFIG_MODULE="$BASE_OUTILS/MODULE"
FICHIER_CONFIG_MODULE_INFO="$BASE_OUTILS/Config/MODULE-INFODEV"
DEFAULT_REP_CORE=`dirname $BASE_OUTILS`/Core
DEFAULT_REP_IHM=`dirname $BASE_OUTILS`/easymaths
#########################################


## Initialisation des paramtres ########
DATE=`date`
AUTEUR="Didier Davill"
ADRESSE_AUTEUR="Didier.Daville@LibertySurf.fr"
DEFAULT_MODULE=EasyMaths
FICHIER_HEADER_CONFIG="$DEFAULT_REP_IHM/Config.h"
#########################################


## Cration de l'archivage ##############
AfficherAide ( )
{
	echo "Mode d'utilisation "
	echo "	version [OPTION] [MODULE]"
	echo "  Avec OPTION"
	echo "	-h			Affiche l'aide"
	echo "	-help			Affiche l'aide"
	echo "	-next 	 [MODULE]	Affiche la prochaine version de module"
	echo "	-current [MODULE]	Affiche la version courante de module"
}
#########################################


## Cration de l'archivage ##############
CreerFichierHeaderConfig ( )
{
	# Mise  jour du fichier Config.h
	echo "// Fichier gnr le "$DATE" par l'utilitaire Version">$FICHIER_HEADER_CONFIG
	echo "		">>$FICHIER_HEADER_CONFIG
	echo "#ifndef XM_CONFIG_H" >>$FICHIER_HEADER_CONFIG
	echo "#define XM_CONFIG_H" >>$FICHIER_HEADER_CONFIG
	echo >>$FICHIER_HEADER_CONFIG
	echo "#define XM_AUTEUR			\"$AUTEUR\"" >>$FICHIER_HEADER_CONFIG
	echo "#define XM_ADRESSE_AUTEUR		\"$ADRESSE_AUTEUR\"" >>$FICHIER_HEADER_CONFIG
	echo "#define XM_VERSION_MAYOR		\"`"$NOM_OUTIL" -current| cut -d. -f1`\""  >>$FICHIER_HEADER_CONFIG
	echo "#define XM_VERSION_MEDIUM		\"`"$NOM_OUTIL" -current| cut -d. -f2`\"" >>$FICHIER_HEADER_CONFIG
	echo "#define XM_VERSION_MINOR		\"`"$NOM_OUTIL" -current| cut -d. -f3`\""  >>$FICHIER_HEADER_CONFIG
	echo "#define XM_VERSION			\"`"$NOM_OUTIL" -current`\"" >>$FICHIER_HEADER_CONFIG
	echo "#define XM_LAST_VERSION_DATE		\"$DATE\""  >>$FICHIER_HEADER_CONFIG
	echo >>$FICHIER_HEADER_CONFIG
	echo "#endif   /*XM_CONFIG_H*/" >>$FICHIER_HEADER_CONFIG
	cp -f "$FICHIER_HEADER_CONFIG" "$DEFAULT_REP_CORE"
}
#########################################


## Operation de version #################
function UpdateVersion ( )
{
	Action="$1"
	Module="$2"
	FICHIER_VERSION="$3"
	VERSION_MODULE_VALUE=`grep %$Module% $FICHIER_VERSION`
	if [ X"$VERSION_MODULE_VALUE" = X ]; then
		RESULT=no
		return
	fi
	OLD_VERSION_MODULE=`echo $VERSION_MODULE_VALUE|cut -d: -f6`
	VERSION_MAYOR=`echo $OLD_VERSION_MODULE | cut -d. -f1`
	VERSION_MEDIUM=`echo $OLD_VERSION_MODULE | cut -d. -f2`
	VERSION_MINOR=`echo $OLD_VERSION_MODULE | cut -d. -f3`
	VERSION_MODULE=$VERSION_MAYOR$VERSION_MEDIUM$VERSION_MINOR
	NEW_VERSION_MODULE=`expr $VERSION_MODULE $Action 1`
	while [ `expr length $NEW_VERSION_MODULE` -lt 6 ];
	do
		NEW_VERSION_MODULE=0$NEW_VERSION_MODULE
	done
	VERSION_MAYOR=`expr substr $NEW_VERSION_MODULE 1 2`
	VERSION_MEDIUM=`expr substr $NEW_VERSION_MODULE 3 2`
	VERSION_MINOR=`expr substr $NEW_VERSION_MODULE 5 2`
	NEW_VERSION_MODULE="$VERSION_MAYOR.$VERSION_MEDIUM.$VERSION_MINOR"
	NEW_VERSION_MODULE_VALUE=`echo $VERSION_MODULE_VALUE|sed s/$OLD_VERSION_MODULE/$NEW_VERSION_MODULE/g`
	
	cp $FICHIER_VERSION $FICHIER_VERSION.sav
	sed s/$VERSION_MODULE_VALUE/$NEW_VERSION_MODULE_VALUE/g $FICHIER_VERSION.sav>$FICHIER_VERSION
	rm $FICHIER_VERSION.sav
	if [ $Module=$DEFAULT_MODULE ]; then
		CreerFichierHeaderConfig
	fi
}
#########################################


## Procdure principale	#################
ProcedurePrincipale ( )
{
	Option=$1
	if [ $# = 2 ]; then
		Module=$2
	else
		Module=$DEFAULT_MODULE
	fi
	case $Option in
		-h)AffichierAide;;
		-help) AfficherAide;;
		-prev)
			UpdateVersion "-" "$Module" "$FICHIER_CONFIG_MODULE"
			if [ X"$RESULT" = Xno ];then
				UpdateVersion "-" "$Module" "$FICHIER_CONFIG_MODULE_INFO"
			fi
			;;
		-next) UpdateVersion "+" "$Module" "$FICHIER_CONFIG_MODULE"
			if [ X"$RESULT" = Xno ];then
				UpdateVersion "+" "$Module" "$FICHIER_CONFIG_MODULE_INFO"
			fi
			;;
		-current)
			VERSION_FOUND=`grep %$Module% $FICHIER_CONFIG_MODULE|cut -d: -f6`
			if [ X"$VERSION_FOUND" = X ]; then
				grep "%$Module%" $FICHIER_CONFIG_MODULE_INFO|cut -d: -f6
				exit 0
			fi
			echo "$VERSION_FOUND"
			;;
		-creerconfig)
			CreerFichierHeaderConfig
			;;
		*) AfficherAide;;
	esac
}
#########################################


## Lancement de la procedure principale #
ProcedurePrincipale $* ##################
#########################################